/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     LEFTPAR = 258,
     RIGHTPAR = 259,
     NAME = 260,
     DEF_NAME = 261,
     TWODOTS = 262,
     HYPHEN = 263,
     DEFINE = 264,
     DOMAIN = 265,
     REQUIREMENTS = 266,
     CONSTANTS = 267,
     PREDICATES = 268,
     QUESTION = 269,
     EITHER = 270,
     NOT = 271,
     AND = 272,
     OR = 273,
     FORALL = 274,
     WHEN = 275,
     EQUAL = 276,
     ACTION = 277,
     OBSERVE = 278,
     EQUALITY = 279,
     CONDITIONAL_EFFECTS = 280,
     NEGATIVE_PRECONDITIONS = 281,
     PARAMETERS = 282,
     PRECONDITION = 283,
     EFFECT = 284,
     PROBLEM = 285,
     INIT = 286,
     GOAL = 287,
     STRUCTURAL = 288,
     SITUATION = 289,
     OBJECTS = 290,
     SERIAL = 291,
     PARALLEL = 292,
     INTEGER = 293,
     FLOAT = 294,
     SET = 295,
     TYPING = 296,
     STRIPS = 297,
     TYPES = 298,
     CERTAINTY = 299,
     KNOW = 300,
     UNKNOWN = 301,
     DEFINED = 302,
     FORMULA = 303,
     ONEOF = 304
   };
#endif
/* Tokens.  */
#define LEFTPAR 258
#define RIGHTPAR 259
#define NAME 260
#define DEF_NAME 261
#define TWODOTS 262
#define HYPHEN 263
#define DEFINE 264
#define DOMAIN 265
#define REQUIREMENTS 266
#define CONSTANTS 267
#define PREDICATES 268
#define QUESTION 269
#define EITHER 270
#define NOT 271
#define AND 272
#define OR 273
#define FORALL 274
#define WHEN 275
#define EQUAL 276
#define ACTION 277
#define OBSERVE 278
#define EQUALITY 279
#define CONDITIONAL_EFFECTS 280
#define NEGATIVE_PRECONDITIONS 281
#define PARAMETERS 282
#define PRECONDITION 283
#define EFFECT 284
#define PROBLEM 285
#define INIT 286
#define GOAL 287
#define STRUCTURAL 288
#define SITUATION 289
#define OBJECTS 290
#define SERIAL 291
#define PARALLEL 292
#define INTEGER 293
#define FLOAT 294
#define SET 295
#define TYPING 296
#define STRIPS 297
#define TYPES 298
#define CERTAINTY 299
#define KNOW 300
#define UNKNOWN 301
#define DEFINED 302
#define FORMULA 303
#define ONEOF 304




/* Copy the first part of user declarations.  */
#line 1 "parser.y"

/*
 *  Copyright (C) 2006 Universitat Pompeu Fabra
 *
 *  Permission is hereby granted to distribute this software for
 *  non-commercial research purposes, provided that this copyright
 *  notice is included with any such distribution.
 *
 *  THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
 *  EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE
 *  SOFTWARE IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU
 *  ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
 *
 *  Blai Bonet, bonet@ldc.usb.ve
 *  Hector Palacios, hector.palacios@upf.edu, hectorpal@gmail.com
 *
 */

#include <stdio.h>
#include <assert.h>
#include <iostream>

#include <map>
#include <nnf.h>

#include "parser.h"
#include "planner.h"

#ifdef USE_CLAUSE
#include "clauses.hpp"
#endif

  // Sometimes it use a lot the stack...
#define YYINITDEPTH 5000

extern int yylex(void);
using namespace std;


/*******************************************************************************
 **
 **   Global Data
 **
 ******************************************************************************/

int                _low_numberSchema = 0;
char*              _low_yyfile = NULL;
char*              _low_problemName = NULL;
char*              _low_domainName = NULL;
char**             _low_schemaName = NULL;
char**             _low_objectName = NULL;
char**             _low_predicateName = NULL;
int                _low_numberPredicates = 0;
int                _low_requirements = 0;
schema_t*          _low_schemaTable[MAXSCHEMA];
int**              _low_initialAtoms;

// operators
operator_t         _low_operator;
int                _low_groundingOperators;

// variables and domain instantiation
int**              _low_vars = NULL;
int**              _low_values = NULL;

// initial/goal formulas
formula_t*         structural = NULL;
formula_t*         initialSituation = NULL;
formula_t*         goalSituation = NULL;

// tables
typedef map<const char*,formula_t*,ltstr> str2wff_t;
str2wff_t predicates;
str2wff_t defined;
map<const char*,idList_t*,ltstr>   objects;
map<const char*,idList_t*,ltstr>   types;


/*******************************************************************************
 **
 **   Static Global Data
 **
 ******************************************************************************/

static int         domainParsed = 0;
static int         maxParameters = 0;
static int         numberObjects = 0;
static schema_t*   schemas = NULL;


/*******************************************************************************
 **
 **   Forward References
 **
 ******************************************************************************/

static void       checkRequirement( int );
static formula_t* unfoldQuantifiers( formula_t* );
static formula_t* linearizeEffect( formula_t*, formula_t*& );
       void       printFormula( FILE*, formula_t* );
       void       printFormulaPDDL( ostream& o, formula_t *formula );
       void       printInitialPDDL( ostream& out, formula_t *formula );
static nnf::node  generateEffect( nnf::Manager*, nnf::node, formula_t*, int*, lit_effect_t& );
//static void       collectEffectAtoms( formula_t*, int*, std::vector<int>& );
static void       collectEffectAtoms( formula_t*, int*, std::vector<int>&, std::vector<int> *atoms_conds = 0 );
static nnf::node  generateAtomicFormula( nnf::Manager*, formula_t *, int*, bool );
       nnf::node  generateFormula( nnf::Manager*, formula_t*, int*, bool );
static void       collectPlainFormulaAtoms( formula_t* formula, int* parameters, 
					    std::vector<int> &atoms );
static void       collectFormulaAtomsPos( formula_t*, int*, std::vector<int>& );
static void       collectFormulaAtoms( formula_t*, int*, std::vector<int>& );
static int        atomId( formula_t *literal, int* parameters );

 static void idMatchArgsVars( formula_t *formula, idList_t *vars );
 static void generateNames( void );
 static instantiation_t * buildInstantiation( idList_t *vars, idList_t *args );
 static formula_t * copyReplaceFormula( formula_t *formula, instantiation_t *inst );
 void yyerror( char const *s );


extern int        lineno;
extern int        numberAtoms;
extern iatom_t*   readAtomHash( int* );
extern std::map<int,int> inv_reachable;
extern std::map<int,int> reachable;
extern unsigned   time_shift;
extern bool observation_detected;


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 335 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   271

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  50
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  59
/* YYNRULES -- Number of rules.  */
#define YYNRULES  121
/* YYNRULES -- Number of states.  */
#define YYNSTATES  235

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   304

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    11,    12,    13,    14,    15,
      29,    33,    36,    39,    42,    45,    48,    51,    54,    56,
      58,    60,    62,    64,    66,    69,    72,    74,    79,    81,
      83,    85,    87,    89,    91,    96,   100,   105,   109,   114,
     118,   121,   123,   126,   128,   131,   132,   134,   137,   140,
     143,   145,   150,   152,   154,   159,   162,   164,   166,   168,
     172,   175,   176,   181,   184,   187,   190,   192,   196,   199,
     200,   205,   208,   210,   215,   217,   222,   227,   232,   237,
     242,   250,   253,   255,   260,   265,   268,   269,   271,   273,
     276,   278,   280,   284,   287,   290,   292,   294,   300,   305,
     313,   319,   322,   324,   326,   331,   332,   333,   344,   347,
     348,   352,   356,   361,   366,   371,   377,   382,   385,   387,
     392,   394
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      51,     0,    -1,    52,    -1,    52,   102,    -1,    52,    53,
      -1,    -1,    -1,    -1,    -1,     3,     9,     3,    10,    74,
       4,    54,     3,    57,    55,    80,    56,     4,    -1,    57,
      58,     3,    -1,    58,     3,    -1,    11,    59,    -1,    43,
      62,    -1,    12,    63,    -1,    13,    76,    -1,    60,     4,
      -1,    60,    61,    -1,    61,    -1,    41,    -1,    25,    -1,
      26,    -1,    24,    -1,    42,    -1,    65,     4,    -1,    66,
       4,    -1,    74,    -1,     3,    15,    71,     4,    -1,    68,
      -1,    71,    -1,    69,    -1,    72,    -1,    70,    -1,    73,
      -1,    68,    71,     8,    64,    -1,    71,     8,    64,    -1,
      69,    72,     8,    64,    -1,    72,     8,    64,    -1,    73,
       8,    64,    70,    -1,    73,     8,    64,    -1,    71,    74,
      -1,    74,    -1,    72,    74,    -1,    74,    -1,    75,    73,
      -1,    -1,     5,    -1,    14,    74,    -1,    77,     4,    -1,
      77,    78,    -1,    78,    -1,     3,    79,    67,     4,    -1,
       5,    -1,    21,    -1,    80,     3,    81,     4,    -1,    81,
       4,    -1,    83,    -1,    87,    -1,    22,    -1,    82,    74,
      84,    -1,    84,    85,    -1,    -1,    27,     3,    86,     4,
      -1,    28,    91,    -1,    29,    96,    -1,    23,    96,    -1,
      67,    -1,    47,    74,    88,    -1,    88,    89,    -1,    -1,
      27,     3,    86,     4,    -1,    48,    91,    -1,    93,    -1,
       3,    16,    93,     4,    -1,    93,    -1,     3,    16,    91,
       4,    -1,     3,    46,    91,     4,    -1,     3,    17,    92,
       4,    -1,     3,    18,    92,     4,    -1,     3,    49,    92,
       4,    -1,     3,    19,     3,    67,     4,    91,     4,    -1,
      92,    91,    -1,    91,    -1,     3,    79,    94,     4,    -1,
       3,     6,    94,     4,    -1,    95,    94,    -1,    -1,    74,
      -1,    75,    -1,    96,    97,    -1,    97,    -1,    99,    -1,
       3,    99,     4,    -1,     3,     4,    -1,    98,    99,    -1,
      99,    -1,    90,    -1,     3,    40,    90,    91,     4,    -1,
       3,    17,    98,     4,    -1,     3,    19,     3,    67,     4,
      99,     4,    -1,     3,    20,    91,   101,     4,    -1,   100,
      90,    -1,    90,    -1,    90,    -1,     3,    17,   100,     4,
      -1,    -1,    -1,     3,     9,     3,    30,    74,     4,   103,
     105,   104,     4,    -1,   105,   106,    -1,    -1,     3,    11,
      59,    -1,     3,    34,   107,    -1,     3,    33,    91,     4,
      -1,     3,    31,    92,     4,    -1,     3,    32,   108,     4,
      -1,     3,     7,    10,    74,     4,    -1,     3,    35,    66,
       4,    -1,    74,     4,    -1,    91,    -1,     3,    45,    92,
       4,    -1,    44,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   161,   161,   165,   166,   167,   178,   182,   187,   177,
     204,   205,   208,   209,   210,   211,   214,   217,   221,   227,
     231,   235,   239,   252,   259,   262,   265,   273,   280,   281,
     285,   286,   294,   295,   298,   306,   316,   325,   336,   345,
     353,   361,   371,   380,   391,   400,   405,   408,   418,   422,
     423,   427,   448,   449,   456,   457,   460,   461,   464,   471,
     548,   554,   559,   565,   571,   577,   585,   595,   623,   629,
     634,   640,   648,   649,   656,   657,   671,   677,   683,   689,
     695,   704,   711,   720,   730,   740,   749,   754,   755,   759,
     766,   773,   783,   787,   795,   802,   812,   813,   820,   826,
     833,   874,   881,   891,   892,   908,   912,   907,   920,   921,
     924,   925,   926,   930,   934,   938,   939,   942,   945,   946,
     952,   958
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "LEFTPAR", "RIGHTPAR", "NAME",
  "DEF_NAME", "TWODOTS", "HYPHEN", "DEFINE", "DOMAIN", "REQUIREMENTS",
  "CONSTANTS", "PREDICATES", "QUESTION", "EITHER", "NOT", "AND", "OR",
  "FORALL", "WHEN", "EQUAL", "ACTION", "OBSERVE", "EQUALITY",
  "CONDITIONAL_EFFECTS", "NEGATIVE_PRECONDITIONS", "PARAMETERS",
  "PRECONDITION", "EFFECT", "PROBLEM", "INIT", "GOAL", "STRUCTURAL",
  "SITUATION", "OBJECTS", "SERIAL", "PARALLEL", "INTEGER", "FLOAT", "SET",
  "TYPING", "STRIPS", "TYPES", "CERTAINTY", "KNOW", "UNKNOWN", "DEFINED",
  "FORMULA", "ONEOF", "$accept", "start", "list_domain_problem", "domain",
  "@1", "@2", "@3", "list_def", "definition", "require_def",
  "list_require_key", "require_key", "types_def", "constants_def", "type",
  "plain_or_typed_list_type", "plain_or_typed_list_name",
  "plain_or_typed_list_var", "typed_list_type", "typed_list_name",
  "typed_list_var", "list_type", "list_name", "list_var", "name",
  "variable", "predicates_def", "list_atomic_formula_skeleton",
  "atomic_formula_skeleton", "predicate", "list_structure_def",
  "structure_def", "action_type", "schema_def", "list_schema_body",
  "schema_body", "list_parameters", "defined_def", "list_defined_body",
  "defined_body", "literal", "formula", "list_formula", "atomic_formula",
  "list_term", "term", "non_det_effect_list", "non_det_effect",
  "list_one_effect_formula", "one_effect_formula", "list_literal",
  "list_atomic_effect", "problem", "@4", "@5", "list_def_prob", "def_prob",
  "situation_def", "goal_formula", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    50,    51,    52,    52,    52,    54,    55,    56,    53,
      57,    57,    58,    58,    58,    58,    59,    60,    60,    61,
      61,    61,    61,    61,    62,    63,    64,    64,    65,    65,
      66,    66,    67,    67,    68,    68,    69,    69,    70,    70,
      71,    71,    72,    72,    73,    73,    74,    75,    76,    77,
      77,    78,    79,    79,    80,    80,    81,    81,    82,    83,
      84,    84,    85,    85,    85,    85,    86,    87,    88,    88,
      89,    89,    90,    90,    91,    91,    91,    91,    91,    91,
      91,    92,    92,    93,    93,    94,    94,    95,    95,    96,
      96,    96,    97,    97,    98,    98,    99,    99,    99,    99,
      99,   100,   100,   101,   101,   103,   104,   102,   105,   105,
     106,   106,   106,   106,   106,   106,   106,   107,   108,   108,
     108,   108
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     0,     0,     0,     0,    13,
       3,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     1,     1,     1,     2,     2,     1,     4,     1,     1,
       1,     1,     1,     1,     4,     3,     4,     3,     4,     3,
       2,     1,     2,     1,     2,     0,     1,     2,     2,     2,
       1,     4,     1,     1,     4,     2,     1,     1,     1,     3,
       2,     0,     4,     2,     2,     2,     1,     3,     2,     0,
       4,     2,     1,     4,     1,     4,     4,     4,     4,     4,
       7,     2,     1,     4,     4,     2,     0,     1,     1,     2,
       1,     1,     3,     2,     2,     1,     1,     5,     4,     7,
       5,     2,     1,     1,     4,     0,     0,    10,     2,     0,
       3,     3,     4,     4,     4,     5,     4,     2,     1,     4,
       1,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       5,     0,     2,     1,     0,     4,     3,     0,     0,     0,
       0,    46,     0,     0,     6,   105,     0,   109,     0,   106,
       0,     0,     0,     0,     7,     0,     0,     0,   108,    22,
      20,    21,    19,    23,    12,     0,    18,    14,     0,    30,
      31,    43,     0,    15,     0,    50,    13,     0,    28,    29,
      41,     0,     0,    11,     0,     0,     0,   121,     0,     0,
       0,   107,    16,    17,    25,     0,     0,    42,    52,    53,
      45,    48,    49,    24,     0,     0,    40,    58,     0,     8,
       0,     0,    56,    57,    10,     0,   110,     0,    82,     0,
      74,     0,   120,   118,     0,     0,     0,   111,     0,     0,
       0,    37,    26,     0,     0,    32,    33,    45,     0,    35,
      69,     0,     0,    55,    61,     0,    86,     0,     0,     0,
       0,     0,     0,    86,   113,    81,     0,   114,   112,   117,
     116,    36,     0,    47,    51,     0,    44,    34,    67,     0,
       9,    59,   115,    87,    88,     0,    86,     0,     0,     0,
      45,     0,     0,     0,     0,     0,    39,     0,     0,    68,
      54,     0,     0,     0,     0,    60,    84,    85,    75,    77,
      78,     0,    76,    79,    83,   119,    27,    38,     0,    45,
      71,     0,    96,    72,    65,    90,    91,    45,    63,    64,
       0,    66,     0,     0,    93,     0,     0,     0,     0,     0,
       0,     0,    89,     0,     0,    70,     0,     0,     0,    95,
      45,     0,     0,     0,    92,    62,    80,    73,    98,    94,
       0,     0,   103,     0,     0,     0,     0,   100,    97,     0,
     102,     0,    99,   104,   101
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,     5,    16,    51,   112,    24,    25,    34,
      35,    36,    46,    37,   101,    47,    38,   191,    48,    39,
     105,    49,    40,   106,   102,   107,    43,    44,    45,   123,
      79,    80,    81,    82,   141,   165,   192,    83,   138,   159,
     182,    88,    89,    90,   145,   146,   184,   185,   208,   186,
     231,   223,     6,    17,    27,    19,    28,    97,    94
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -170
static const yytype_int16 yypact[] =
{
    -170,    39,    46,  -170,    57,  -170,  -170,    68,    32,    70,
      70,  -170,    76,   107,  -170,  -170,   111,  -170,    16,   124,
     145,    70,   129,    70,    16,   133,   146,   140,  -170,  -170,
    -170,  -170,  -170,  -170,  -170,   105,  -170,  -170,   155,    70,
      60,  -170,    42,  -170,     9,  -170,  -170,   158,    70,    74,
    -170,   -14,   163,  -170,   166,   145,   165,    13,   165,    70,
      70,  -170,  -170,  -170,  -170,    82,    95,  -170,  -170,  -170,
     159,  -170,  -170,  -170,   102,    95,  -170,  -170,    70,   194,
     199,    70,  -170,  -170,  -170,    70,  -170,    99,  -170,    90,
    -170,     5,  -170,  -170,   213,   214,   215,  -170,   216,    95,
     206,  -170,  -170,    70,   218,  -170,   217,   159,    95,  -170,
    -170,   -14,   219,  -170,  -170,   220,    29,   165,   165,   165,
     223,   165,   165,    29,  -170,  -170,   165,  -170,  -170,  -170,
    -170,  -170,    70,  -170,  -170,    95,  -170,  -170,   -18,   224,
    -170,   173,  -170,  -170,  -170,   225,    29,   226,   122,   151,
     159,   227,   202,   228,   204,   205,    38,   230,   165,  -170,
    -170,   231,   232,   165,   231,  -170,  -170,  -170,  -170,  -170,
    -170,   233,  -170,  -170,  -170,  -170,  -170,  -170,   217,   159,
    -170,   118,  -170,  -170,   235,  -170,  -170,   159,  -170,   235,
     165,  -170,   236,   144,  -170,   238,   239,   240,   165,   241,
     242,   208,  -170,   243,   244,  -170,   183,   245,   210,  -170,
     159,   247,   169,   165,  -170,  -170,  -170,  -170,  -170,  -170,
     248,   177,  -170,   249,   250,   239,   241,  -170,  -170,   251,
    -170,   212,  -170,  -170,  -170
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,   203,   181,
    -170,   221,  -170,  -170,   -68,  -170,   179,   -67,  -170,  -170,
      89,   -46,   222,  -103,    -4,   -98,  -170,  -170,   207,   229,
    -170,   147,  -170,  -170,  -170,  -170,    72,  -170,  -170,  -170,
     -59,   -57,    73,  -123,  -109,  -170,    93,  -169,  -170,  -112,
    -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170,  -170
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -46
static const yytype_int16 yytable[] =
{
      93,    95,    74,   104,   136,    12,    13,   109,    77,   157,
      68,   116,    42,    71,   153,   202,    91,    41,   144,    50,
     202,   117,   118,   119,   120,   144,    69,    20,    21,    22,
     158,   131,   125,    78,    11,    41,    67,   167,   183,     3,
     137,   183,     9,   103,    50,    76,   -45,    68,   144,     4,
     126,   121,   103,   178,   122,    96,    41,    92,   183,    23,
     147,    67,    10,    69,   151,    11,     7,   156,    66,   200,
      76,     8,   207,   183,   110,    11,   183,   114,   183,    11,
      14,   115,    75,   171,   209,   183,   155,    11,   183,   200,
      99,   125,   125,    87,   124,   125,   219,   125,   100,   133,
      11,   180,   183,   183,    68,   116,   188,    11,   183,    62,
     108,    15,   143,   229,    18,   117,   118,   119,   120,   143,
      69,   193,   194,    68,   116,    87,   169,    26,    50,    29,
      30,    31,    42,   204,   195,   196,    53,   197,   198,    69,
     213,   211,   143,   220,    61,   121,    32,    33,   122,    68,
     116,    76,   222,    54,    87,   170,   224,    55,   199,    64,
     195,   196,    73,   197,   198,    69,    84,   230,    87,    29,
      30,    31,   234,   103,    68,   116,    85,    56,    57,    58,
      59,    60,    68,   116,   199,   195,    32,    33,    68,   116,
      69,   148,   149,   195,   226,   152,   161,   111,    69,   154,
     162,   163,   164,   113,    69,    87,   173,    87,   175,   176,
      11,   193,   194,   193,   218,   212,   233,   127,   128,   129,
     130,   132,   134,   140,   142,   135,   150,    52,   160,   166,
     168,   172,   174,   179,   181,   187,    86,   190,   201,    98,
     205,   206,   193,   210,   212,   177,   214,   215,   216,   217,
     221,    72,   225,   227,   228,   232,    63,   189,   139,   203,
       0,    65,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    70
};

static const yytype_int16 yycheck[] =
{
      57,    58,    48,    70,   107,     9,    10,    75,    22,    27,
       5,     6,     3,     4,   123,   184,     3,    21,   116,    23,
     189,    16,    17,    18,    19,   123,    21,    11,    12,    13,
      48,    99,    89,    47,     5,    39,    40,   146,   161,     0,
     108,   164,    10,    14,    48,    49,     8,     5,   146,     3,
      45,    46,    14,   156,    49,    59,    60,    44,   181,    43,
     117,    65,    30,    21,   121,     5,     9,   135,     8,   181,
      74,     3,   195,   196,    78,     5,   199,    81,   201,     5,
       4,    85,     8,   150,   196,   208,   132,     5,   211,   201,
       8,   148,   149,     3,     4,   152,   208,   154,     3,   103,
       5,   158,   225,   226,     5,     6,   163,     5,   231,     4,
       8,     4,   116,   225,     3,    16,    17,    18,    19,   123,
      21,     3,     4,     5,     6,     3,     4,     3,   132,    24,
      25,    26,     3,   190,    16,    17,     3,    19,    20,    21,
     199,   198,   146,   210,     4,    46,    41,    42,    49,     5,
       6,   155,   211,     7,     3,     4,   213,    11,    40,     4,
      16,    17,     4,    19,    20,    21,     3,   226,     3,    24,
      25,    26,   231,    14,     5,     6,    10,    31,    32,    33,
      34,    35,     5,     6,    40,    16,    41,    42,     5,     6,
      21,   118,   119,    16,    17,   122,    23,     3,    21,   126,
      27,    28,    29,     4,    21,     3,     4,     3,     4,     4,
       5,     3,     4,     3,     4,     3,     4,     4,     4,     4,
       4,    15,     4,     4,     4,     8,     3,    24,     4,     4,
       4,     4,     4,     3,     3,     3,    55,     4,     3,    60,
       4,     3,     3,     3,     3,   156,     4,     4,     4,     4,
       3,    44,     4,     4,     4,     4,    35,   164,   111,   187,
      -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    42
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    51,    52,     0,     3,    53,   102,     9,     3,    10,
      30,     5,    74,    74,     4,     4,    54,   103,     3,   105,
      11,    12,    13,    43,    57,    58,     3,   104,   106,    24,
      25,    26,    41,    42,    59,    60,    61,    63,    66,    69,
      72,    74,     3,    76,    77,    78,    62,    65,    68,    71,
      74,    55,    58,     3,     7,    11,    31,    32,    33,    34,
      35,     4,     4,    61,     4,    72,     8,    74,     5,    21,
      79,     4,    78,     4,    71,     8,    74,    22,    47,    80,
      81,    82,    83,    87,     3,    10,    59,     3,    91,    92,
      93,     3,    44,    91,   108,    91,    74,   107,    66,     8,
       3,    64,    74,    14,    67,    70,    73,    75,     8,    64,
      74,     3,    56,     4,    74,    74,     6,    16,    17,    18,
      19,    46,    49,    79,     4,    91,    45,     4,     4,     4,
       4,    64,    15,    74,     4,     8,    73,    64,    88,    81,
       4,    84,     4,    74,    75,    94,    95,    91,    92,    92,
       3,    91,    92,    94,    92,    71,    64,    27,    48,    89,
       4,    23,    27,    28,    29,    85,     4,    94,     4,     4,
       4,    67,     4,     4,     4,     4,     4,    70,    73,     3,
      91,     3,    90,    93,    96,    97,    99,     3,    91,    96,
       4,    67,    86,     3,     4,    16,    17,    19,    20,    40,
      99,     3,    97,    86,    91,     4,     3,    93,    98,    99,
       3,    91,     3,    90,     4,     4,     4,     4,     4,    99,
      67,     3,    90,   101,    91,     4,    17,     4,     4,    99,
      90,   100,     4,     4,    90
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 6:
#line 178 "parser.y"
    {
			 _low_domainName = (yyvsp[(5) - (6)].ident);
		       }
    break;

  case 7:
#line 182 "parser.y"
    {
			 idMatchArgsVars( initialSituation, NULL );
			 idMatchArgsVars( goalSituation, NULL );
		       }
    break;

  case 8:
#line 187 "parser.y"
    {
			 /* how much parameters can an schema have? */
			 for( schema_t *sch = schemas; sch != NULL; sch = sch->next )
			   {
			     int i;
			     idList_t *var;
			     for( var = sch->vars, i = 0; var != NULL; var = var->next, ++i );
			     maxParameters = MAX(maxParameters,i);
			   }
			 generateNames();
		       }
    break;

  case 9:
#line 199 "parser.y"
    {
			 domainParsed = 1;
		       }
    break;

  case 17:
#line 218 "parser.y"
    {
			 checkRequirement( (yyvsp[(2) - (2)].integer) );
		       }
    break;

  case 18:
#line 222 "parser.y"
    {
			 checkRequirement( (yyvsp[(1) - (1)].integer) );
		       }
    break;

  case 19:
#line 228 "parser.y"
    {
			 (yyval.integer) = TYPING;
		       }
    break;

  case 20:
#line 232 "parser.y"
    {
			 (yyval.integer) = CONDITIONAL_EFFECTS;
		       }
    break;

  case 21:
#line 236 "parser.y"
    {
			 (yyval.integer) = NEGATIVE_PRECONDITIONS;
		       }
    break;

  case 22:
#line 240 "parser.y"
    {
			 (yyval.integer) = EQUALITY;

			 /* create the equal predicate */
			 formula_t *pred = (formula_t*)malloc( sizeof( formula_t ) );
			 pred->type = ATOMIC_FORMULA;
			 pred->u.atomic.id = ++_low_numberPredicates;
			 pred->u.atomic.neg = 0;
			 pred->u.atomic.equal = 1;
			 pred->u.atomic.name = strdup( "=" );
			 predicates[pred->u.atomic.name] = pred;
		       }
    break;

  case 23:
#line 253 "parser.y"
    {
			 (yyval.integer) = STRIPS;
		       }
    break;

  case 26:
#line 266 "parser.y"
    {
			 (yyval.idlist) = (idList_t*)malloc( sizeof( idList_t ) );
			 (yyval.idlist)->id = 0;
			 (yyval.idlist)->name = (yyvsp[(1) - (1)].ident);
			 (yyval.idlist)->type = NULL;
			 (yyval.idlist)->next = NULL;
		       }
    break;

  case 27:
#line 274 "parser.y"
    {
			 (yyval.idlist) = (yyvsp[(3) - (4)].idlist);
		       }
    break;

  case 31:
#line 287 "parser.y"
    {
			 for( idList_t *id = (yyvsp[(1) - (1)].idlist); id != NULL; id = id->next )
			   objects[id->name] = id;
		       }
    break;

  case 34:
#line 299 "parser.y"
    {
			 for( idList_t *id = (yyvsp[(2) - (4)].idlist); id != NULL; id = id->next )
			   {
			     id->type = (yyvsp[(4) - (4)].idlist);
			     types[id->name] = id;
			   }
		       }
    break;

  case 35:
#line 307 "parser.y"
    {
			 for( idList_t *id = (yyvsp[(1) - (3)].idlist); id != NULL; id = id->next )
			   {
			     id->type = (yyvsp[(3) - (3)].idlist);
			     types[id->name] = id;
			   }
		       }
    break;

  case 36:
#line 317 "parser.y"
    {
			 for( idList_t *id = (yyvsp[(2) - (4)].idlist); id != NULL; id = id->next )
			   {
			     id->type = (yyvsp[(4) - (4)].idlist);
			     objects[id->name] = id;
			     //xxxx printf( "object %s has id %d\n", id->name, id->id );
			   }
		       }
    break;

  case 37:
#line 326 "parser.y"
    {
			 for( idList_t *id = (yyvsp[(1) - (3)].idlist); id != NULL; id = id->next )
			   {
			     id->type = (yyvsp[(3) - (3)].idlist);
			     objects[id->name] = id;
			     //xxxx printf( "object %s has id %d\n", id->name, id->id );
			   }
		       }
    break;

  case 38:
#line 337 "parser.y"
    {
			 idList_t *name;
			 for( name = (yyvsp[(1) - (4)].idlist); name->next != NULL; name = name->next )
			   name->type = (yyvsp[(3) - (4)].idlist);
			 name->type = (yyvsp[(3) - (4)].idlist);
			 name->next = (yyvsp[(4) - (4)].idlist);
			 (yyval.idlist) = (yyvsp[(1) - (4)].idlist);
		       }
    break;

  case 39:
#line 346 "parser.y"
    {
			 for( idList_t *name = (yyvsp[(1) - (3)].idlist); name != NULL; name = name->next )
			   name->type = (yyvsp[(3) - (3)].idlist);
			 (yyval.idlist) = (yyvsp[(1) - (3)].idlist);
		       }
    break;

  case 40:
#line 354 "parser.y"
    {
			 (yyval.idlist) = (idList_t*)malloc( sizeof( idList_t ) );
			 (yyval.idlist)->id = 0;
			 (yyval.idlist)->name = (yyvsp[(2) - (2)].ident);
			 (yyval.idlist)->type = NULL;
			 (yyval.idlist)->next = (yyvsp[(1) - (2)].idlist);
		       }
    break;

  case 41:
#line 362 "parser.y"
    {
			 (yyval.idlist) = (idList_t*)malloc( sizeof( idList_t ) );
			 (yyval.idlist)->id = 0;
			 (yyval.idlist)->name = (yyvsp[(1) - (1)].ident);
			 (yyval.idlist)->type = NULL;
			 (yyval.idlist)->next = NULL;
		       }
    break;

  case 42:
#line 372 "parser.y"
    {
			 (yyval.idlist) = (idList_t*)malloc( sizeof( idList_t ) );
			 (yyval.idlist)->id = ++numberObjects;
			 (yyval.idlist)->name = (yyvsp[(2) - (2)].ident);
			 (yyval.idlist)->type = NULL;
			 (yyval.idlist)->next = (yyvsp[(1) - (2)].idlist);
			 //objects[$$->name] = $$;
		       }
    break;

  case 43:
#line 381 "parser.y"
    {
			 (yyval.idlist) = (idList_t*)malloc( sizeof( idList_t ) );
			 (yyval.idlist)->id = ++numberObjects;
			 (yyval.idlist)->name = (yyvsp[(1) - (1)].ident);
			 (yyval.idlist)->type = NULL;
			 (yyval.idlist)->next = NULL;
			 //objects[$$->name] = $$;
		       }
    break;

  case 44:
#line 392 "parser.y"
    {
			 (yyval.idlist) = (idList_t*)malloc( sizeof( idList_t ) );
			 (yyval.idlist)->id = 0;
			 (yyval.idlist)->name = (yyvsp[(1) - (2)].ident);
			 (yyval.idlist)->type = NULL;
			 (yyval.idlist)->next = (yyvsp[(2) - (2)].idlist);
		       }
    break;

  case 45:
#line 400 "parser.y"
    {  
			 (yyval.idlist) = NULL;
		       }
    break;

  case 47:
#line 409 "parser.y"
    {
			 (yyval.ident) = (char*)malloc( strlen( (yyvsp[(2) - (2)].ident) ) + 2 );
			 (yyval.ident)[0] = '\0';
			 strcat( (yyval.ident), "?" );
			 strcat( (yyval.ident), (yyvsp[(2) - (2)].ident) );
			 free( (yyvsp[(2) - (2)].ident) );
		       }
    break;

  case 51:
#line 428 "parser.y"
    {
			 formula_t *pred = (formula_t*)malloc( sizeof( formula_t ) );
			 pred->type = ATOMIC_FORMULA;
			 pred->u.atomic.id = ++_low_numberPredicates;
			 pred->u.atomic.neg = 0;
			 pred->u.atomic.name = (yyvsp[(2) - (4)].ident);
			 pred->u.atomic.equal = 0;
			 pred->u.atomic.args = (yyvsp[(3) - (4)].idlist);
			 predicates[pred->u.atomic.name] = pred;
			 assert( pred->u.atomic.name != 0 );
			 // AQUI!!!
			 for( str2wff_t::iterator it = predicates.begin(); 
			      it != predicates.end(); 
			      it++ )
			   assert( it->first != 0 );
			 cout << "predicates size = " << predicates.size() 
			      << " for name = " << predicates[pred->u.atomic.name]->u.atomic.name << endl;
		       }
    break;

  case 53:
#line 450 "parser.y"
    {
			 (yyval.ident) = "=";
		       }
    break;

  case 58:
#line 465 "parser.y"
    {
			 (yyval.integer) = ACTION;
		       }
    break;

  case 59:
#line 472 "parser.y"
    {
			 formula_t *f1, *f2, *f3;

			 schema_t *schema = (schema_t*)malloc( sizeof( schema_t ) );
			 schema->name = (yyvsp[(2) - (3)].ident);
			 schema->vars = NULL;
			 schema->prec = NULL;
			 schema->effect = NULL;
			 schema->next = NULL;

			 bool saw_effect = false, saw_observe = false;
			 for( body_t *body = (yyvsp[(3) - (3)].body); body != NULL; body = body->next )
			   switch( body->type )
			     {
			     case PARAMETERS:
			       schema->vars = body->u.parameters;
			       break;
			     case PRECONDITION:
			       schema->prec = body->u.formula;
			       break;
			     case EFFECT:
			       saw_effect= true;
			       schema->is_observation = false;
			       for( f1 = body->u.formula; f1 != NULL; f1 = f1->u.flist.next )
				 {
				   f2 = (formula_t*)malloc( sizeof( formula_t ) );
				   f2->type = LIST_FORMULA;
				   f2->u.flist.formula = unfoldQuantifiers( f1->u.flist.formula );
				   f2->u.flist.formula = linearizeEffect( f2->u.flist.formula, f3 );
				   f2->u.flist.next = schema->effect;
				   schema->effect = f2;
				 }
			       break;
			     case OBSERVE:
			       saw_observe = true;
			       schema->is_observation = true;
			       observation_detected = true;
			       for( f1 = body->u.formula; f1 != NULL; f1 = f1->u.flist.next )
				 {
				   f2 = (formula_t*)malloc( sizeof( formula_t ) );
				   f2->type = LIST_FORMULA;
				   f2->u.flist.formula = unfoldQuantifiers( f1->u.flist.formula );
				   f2->u.flist.formula = linearizeEffect( f2->u.flist.formula, f3 );
				   f2->u.flist.next = schema->effect;
				   schema->effect = f2;
				 }
			       break;
			     }

			 assert( !saw_effect || !saw_observe );

			 /* if no effect, insert the empty effect */
			 if( !schema->effect )
			   {
			     f2 = (formula_t*)malloc( sizeof( formula_t ) );
			     f2->type = EMPTY_FORMULA;
			     schema->effect = (formula_t*)malloc( sizeof( formula_t ) );
			     schema->effect->type = LIST_FORMULA;
			     schema->effect->u.flist.formula = f2;
			     schema->effect->u.flist.next = NULL;
			   }

			 /* check and identify predicates and vars */
			 idMatchArgsVars( schema->prec, schema->vars );
			 idMatchArgsVars( schema->effect, schema->vars );
			 /* printSchema( stdout, schema ); printf( "\n" ); */

			 /* link schemas */
			 schema->next = schemas;
			 schemas = schema;

			 /* insert schema into schemaTable */
			 _low_schemaTable[_low_numberSchema++] = schema;
		       }
    break;

  case 60:
#line 549 "parser.y"
    {
			 (yyvsp[(2) - (2)].body)->next = (yyvsp[(1) - (2)].body);
			 (yyval.body) = (yyvsp[(2) - (2)].body);
		       }
    break;

  case 61:
#line 554 "parser.y"
    {
			 (yyval.body) = NULL;
		       }
    break;

  case 62:
#line 560 "parser.y"
    {
			 (yyval.body) = (body_t*)malloc( sizeof( body_t ) );
			 (yyval.body)->type = PARAMETERS;
			 (yyval.body)->u.parameters = (yyvsp[(3) - (4)].idlist);
		       }
    break;

  case 63:
#line 566 "parser.y"
    {
			 (yyval.body) = (body_t*)malloc( sizeof( body_t ) );
			 (yyval.body)->type = PRECONDITION;
			 (yyval.body)->u.formula = (yyvsp[(2) - (2)].formula);
		       }
    break;

  case 64:
#line 572 "parser.y"
    {
			 (yyval.body) = (body_t*)malloc( sizeof( body_t ) );
			 (yyval.body)->type = EFFECT;
			 (yyval.body)->u.formula = (yyvsp[(2) - (2)].formula);
		       }
    break;

  case 65:
#line 578 "parser.y"
    {
			 (yyval.body) = (body_t*)malloc( sizeof( body_t ) );
			 (yyval.body)->type = OBSERVE;
			 (yyval.body)->u.formula = (yyvsp[(2) - (2)].formula);
		       }
    break;

  case 66:
#line 586 "parser.y"
    {
			 int i;
			 idList_t *var;
			 for( i = 1, var = (yyvsp[(1) - (1)].idlist); var != NULL; var = var->next )
			   var->id = i++;
			 (yyval.idlist) = (yyvsp[(1) - (1)].idlist);
		       }
    break;

  case 67:
#line 596 "parser.y"
    {
			 formula_t *def = (formula_t*)malloc( sizeof( formula_t ) );
			 def->type = DEFINED_FORMULA;
			 for( body_t *body = (yyvsp[(3) - (3)].body); body != NULL; body = body->next )
			   switch( body->type )
			     {
			     case PARAMETERS:
			       def->u.lambda.vars = body->u.parameters;
			       break;
			     case FORMULA:
			       def->u.lambda.formula = body->u.formula;
			       break;
			     }

			 /* check and identify predicates and vars */
			 idMatchArgsVars( def->u.lambda.formula, def->u.lambda.vars );

			 /* insert into defined table */
			 defined[(yyvsp[(2) - (3)].ident)] = def;
			 /*
			   printf( "defined %s = ", $2 );
			   printFormula( stdout, def->u.lambda.formula );
			   printf( "\n" );
			 */
		       }
    break;

  case 68:
#line 624 "parser.y"
    {
			 (yyvsp[(2) - (2)].body)->next = (yyvsp[(1) - (2)].body);
			 (yyval.body) = (yyvsp[(2) - (2)].body);
		       }
    break;

  case 69:
#line 629 "parser.y"
    {
			 (yyval.body) = NULL;
		       }
    break;

  case 70:
#line 635 "parser.y"
    {
			 (yyval.body) = (body_t*)malloc( sizeof( body_t ) );
			 (yyval.body)->type = PARAMETERS;
			 (yyval.body)->u.parameters = (yyvsp[(3) - (4)].idlist);
		       }
    break;

  case 71:
#line 641 "parser.y"
    {
			 (yyval.body) = (body_t*)malloc( sizeof( body_t ) );
			 (yyval.body)->type = FORMULA;
			 (yyval.body)->u.formula = (yyvsp[(2) - (2)].formula);
		       }
    break;

  case 73:
#line 650 "parser.y"
    {
			 (yyvsp[(3) - (4)].formula)->u.atomic.neg = 1;
			 (yyval.formula) = (yyvsp[(3) - (4)].formula);
		       }
    break;

  case 75:
#line 658 "parser.y"
    {
			 if( (yyvsp[(3) - (4)].formula)->type == ATOMIC_FORMULA )
			   {
			     (yyvsp[(3) - (4)].formula)->u.atomic.neg = ((yyvsp[(3) - (4)].formula)->u.atomic.neg+1)%2;
			     (yyval.formula) = (yyvsp[(3) - (4)].formula);
			   }
			 else
			   {
			     (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			     (yyval.formula)->type = NOT_FORMULA;
			     (yyval.formula)->u.formula = (yyvsp[(3) - (4)].formula);
			   }
		       }
    break;

  case 76:
#line 672 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = UNKNOWN_FORMULA;
			 (yyval.formula)->u.formula = (yyvsp[(3) - (4)].formula);
		       }
    break;

  case 77:
#line 678 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = AND_FORMULA;
			 (yyval.formula)->u.formula = (yyvsp[(3) - (4)].formula);
		       }
    break;

  case 78:
#line 684 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = OR_FORMULA;
			 (yyval.formula)->u.formula = (yyvsp[(3) - (4)].formula);
		       }
    break;

  case 79:
#line 690 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = ONEOF_FORMULA;
			 (yyval.formula)->u.formula = (yyvsp[(3) - (4)].formula);
		       }
    break;

  case 80:
#line 696 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = FORALL_FORMULA;
			 (yyval.formula)->u.lambda.vars = (yyvsp[(4) - (7)].idlist);
			 (yyval.formula)->u.lambda.formula = (yyvsp[(6) - (7)].formula);
		       }
    break;

  case 81:
#line 705 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = LIST_FORMULA;
			 (yyval.formula)->u.flist.formula = (yyvsp[(2) - (2)].formula);
			 (yyval.formula)->u.flist.next = (yyvsp[(1) - (2)].formula);
		       }
    break;

  case 82:
#line 712 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = LIST_FORMULA;
			 (yyval.formula)->u.flist.formula = (yyvsp[(1) - (1)].formula);
			 (yyval.formula)->u.flist.next = NULL;
		       }
    break;

  case 83:
#line 721 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = ATOMIC_FORMULA;
			 (yyval.formula)->u.atomic.id = -1;
			 (yyval.formula)->u.atomic.neg = 0;
			 (yyval.formula)->u.atomic.equal = 0;
			 (yyval.formula)->u.atomic.name = (yyvsp[(2) - (4)].ident);
			 (yyval.formula)->u.atomic.args = (yyvsp[(3) - (4)].idlist);
		       }
    break;

  case 84:
#line 731 "parser.y"
    {
			 instantiation_t *inst;
			 str2wff_t::iterator it;
			 it = defined.find( (yyvsp[(2) - (4)].ident) );
			 inst = buildInstantiation( (*it).second->u.lambda.vars, (yyvsp[(3) - (4)].idlist) );
			 (yyval.formula) = copyReplaceFormula( (*it).second->u.lambda.formula, inst );
		       }
    break;

  case 85:
#line 741 "parser.y"
    {
			 (yyval.idlist) = (idList_t*)malloc( sizeof( idList_t ) );
			 (yyval.idlist)->id = 0;
			 (yyval.idlist)->name = (yyvsp[(1) - (2)].ident);
			 (yyval.idlist)->type = NULL;
			 (yyval.idlist)->next = (yyvsp[(2) - (2)].idlist);
		       }
    break;

  case 86:
#line 749 "parser.y"
    {  
			 (yyval.idlist) = NULL;
		       }
    break;

  case 89:
#line 760 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = LIST_FORMULA;
			 (yyval.formula)->u.flist.formula = (yyvsp[(2) - (2)].formula);
			 (yyval.formula)->u.flist.next = (yyvsp[(1) - (2)].formula);
		       }
    break;

  case 90:
#line 767 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = LIST_FORMULA;
			 (yyval.formula)->u.flist.formula = (yyvsp[(1) - (1)].formula);
			 (yyval.formula)->u.flist.next = NULL;
		       }
    break;

  case 91:
#line 774 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = LIST_FORMULA;
			 (yyval.formula)->u.flist.formula = (yyvsp[(1) - (1)].formula);
			 (yyval.formula)->u.flist.next = NULL;
		       }
    break;

  case 92:
#line 784 "parser.y"
    {
			 (yyval.formula) = (yyvsp[(2) - (3)].formula);
		       }
    break;

  case 93:
#line 788 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = EMPTY_FORMULA;
		       }
    break;

  case 94:
#line 796 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = LIST_FORMULA;
			 (yyval.formula)->u.flist.formula = (yyvsp[(2) - (2)].formula);
			 (yyval.formula)->u.flist.next = (yyvsp[(1) - (2)].formula);
		       }
    break;

  case 95:
#line 803 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = LIST_FORMULA;
			 (yyval.formula)->u.flist.formula = (yyvsp[(1) - (1)].formula);
			 (yyval.formula)->u.flist.next = NULL;
		       }
    break;

  case 97:
#line 814 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = SET_FORMULA;
			 (yyval.formula)->u.fset.literal = (yyvsp[(3) - (5)].formula);
			 (yyval.formula)->u.fset.formula = (yyvsp[(4) - (5)].formula);
		       }
    break;

  case 98:
#line 821 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = AND_FORMULA;
			 (yyval.formula)->u.formula = (yyvsp[(3) - (4)].formula);
		       }
    break;

  case 99:
#line 827 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = FORALL_EFFECT;
			 (yyval.formula)->u.lambda.vars = (yyvsp[(4) - (7)].idlist);
			 (yyval.formula)->u.lambda.formula = (yyvsp[(6) - (7)].formula);
		       }
    break;

  case 100:
#line 834 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 if( (yyvsp[(3) - (5)].formula)->type != OR_FORMULA )
			   {
			     (yyval.formula)->type = WHEN_EFFECT;
			     (yyval.formula)->u.when.formula = (yyvsp[(3) - (5)].formula);
			     (yyval.formula)->u.when.effect = (yyvsp[(4) - (5)].formula);
			   }
			 else
			   {
			     (yyval.formula)->type = AND_FORMULA;
			     formula_t* cont = (formula_t*)malloc( sizeof( formula_t ) );
			     (yyval.formula)->u.formula = cont;
			     formula_t* init = (yyvsp[(3) - (5)].formula)->u.formula;
			     assert( init != NULL );
			     while( init != NULL )
			       {
				 assert( init->type == LIST_FORMULA );
				 cont->type = LIST_FORMULA;
				 // new When...
				 formula_t* newWhen = (formula_t*)malloc( sizeof( formula_t ) );
				 cont->u.flist.formula = newWhen;

				 newWhen->type = WHEN_EFFECT;
				 newWhen->u.when.formula = init->u.flist.formula;
				 newWhen->u.when.effect = copyReplaceFormula( (yyvsp[(4) - (5)].formula), NULL );

				 init = init->u.flist.next;
				 if( init != NULL )
				   {
				     cont->u.flist.next = (formula_t*)malloc( sizeof( formula_t ) );
				     cont = cont->u.flist.next;
				   }
				 else
				   cont->u.flist.next = NULL;
			       }
			   }
		       }
    break;

  case 101:
#line 875 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = LIST_FORMULA;
			 (yyval.formula)->u.flist.formula = (yyvsp[(2) - (2)].formula);
			 (yyval.formula)->u.flist.next = (yyvsp[(1) - (2)].formula);
		       }
    break;

  case 102:
#line 882 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = LIST_FORMULA;
			 (yyval.formula)->u.flist.formula = (yyvsp[(1) - (1)].formula);
			 (yyval.formula)->u.flist.next = NULL;
		       }
    break;

  case 104:
#line 893 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = AND_FORMULA;
			 (yyval.formula) = (yyvsp[(3) - (4)].formula);
		       }
    break;

  case 105:
#line 908 "parser.y"
    {
			 _low_problemName = (yyvsp[(5) - (6)].ident);
		       }
    break;

  case 106:
#line 912 "parser.y"
    {
			 idMatchArgsVars( initialSituation, NULL );
			 idMatchArgsVars( goalSituation, NULL );
			 generateNames();
		       }
    break;

  case 112:
#line 927 "parser.y"
    {
			 structural = (yyvsp[(3) - (4)].formula);
                       }
    break;

  case 113:
#line 931 "parser.y"
    {
			 initialSituation = (yyvsp[(3) - (4)].formula);
                       }
    break;

  case 114:
#line 935 "parser.y"
    {
			 goalSituation = (yyvsp[(3) - (4)].formula);
                       }
    break;

  case 117:
#line 942 "parser.y"
    {}
    break;

  case 119:
#line 947 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = KNOW_FORMULA;
			 (yyval.formula)->u.formula = (yyvsp[(3) - (4)].formula);
		       }
    break;

  case 120:
#line 953 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = CERTAINTY_FORMULA;
		       }
    break;

  case 121:
#line 958 "parser.y"
    {
			 (yyval.formula) = (formula_t*)malloc( sizeof( formula_t ) );
			 (yyval.formula)->type = EMPTY_FORMULA;
		       }
    break;


/* Line 1267 of yacc.c.  */
#line 2630 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 964 "parser.y"


void
yyerror( char const *s )
{
  printf( "%s:%d: %s\n", _low_yyfile, lineno, s );
}

static void
checkRequirement( int req )
{
  switch( req )
    {
    case EQUALITY:
      _low_requirements = _low_requirements | REQ_EQUALITY;
      break;
    case TYPING:
      _low_requirements = _low_requirements | REQ_TYPING;
      break;
    case STRIPS:
      _low_requirements = _low_requirements | REQ_STRIPS;
      break;
    case CONDITIONAL_EFFECTS:
      _low_requirements = _low_requirements | REQ_CONDITIONAL_EFFECTS;
      break;
    case NEGATIVE_PRECONDITIONS:
      _low_requirements = _low_requirements | REQ_NEGATIVE_PRECONDITIONS;
      break;
    default:
      printf( "parser(checkRequirement): not supported requirement %d\n", req );
    }
}

void
printAtomicFormulaPDDL( ostream& o, formula_t *formula )
{
  if( formula != NULL )
    {
      // negation?
      if( formula->u.atomic.neg == 1 )
	o << "(not ";
      o << "(";
      // print name
      o << (formula->u.atomic.equal==1?"=":formula->u.atomic.name);

      // args
      if( formula->u.atomic.args != NULL )
	{
	  o << "_";
	  for( idList_t *arg = formula->u.atomic.args; arg != NULL; arg = arg->next )
	    o << arg->name << (arg->next != NULL ? "_" : ")");
	}
      else
	o << ")";

      if( formula->u.atomic.neg == 1 )
	o << ")";
    }
}


void
printAtomicFormulaPDDLTrans( ostream& o, formula_t *formula, string (*trans)(int) )
{
  int atom = atomId( formula, 0 );
  o << trans(formula->u.atomic.neg?-atom:atom);
}

void
printAtomicFormula( FILE *file, formula_t *formula )
{
  if( formula != NULL )
    {
      // negation?
      if( formula->u.atomic.neg == 1 )
	fprintf( file, "(not " );

      // print name
      fprintf( file, "(%s ", (formula->u.atomic.equal==1?"=":formula->u.atomic.name) );

      // args
      if( formula->u.atomic.args != NULL )
	for( idList_t *arg = formula->u.atomic.args; arg != NULL; arg = arg->next )
	  fprintf( file, "%s%s", arg->name, (arg->next != NULL ? " " : ")") );
      else
	fprintf( file, ")" );

      if( formula->u.atomic.neg == 1 )
	fprintf( file, ")" );
    }
}

void
printFormula( FILE *file, formula_t *formula )
{
  formula_t *f;
  if( formula == NULL )
    fprintf( file, "(null)" );
  else
    {
      switch( formula->type )
	{
	case ATOMIC_FORMULA:
	  printAtomicFormula( file, formula );
	  break;
	case AND_FORMULA:
	  fprintf( file, "(and " );
	  printFormula( file, formula->u.formula );
	  fprintf( file, ")" );
	  break;
	case OR_FORMULA:
	  fprintf( file, "(or " );
	  printFormula( file, formula->u.formula );
	  fprintf( file, ")" );
	  break;
	case ONEOF_FORMULA:
	  fprintf( file, "(oneof " );
	  printFormula( file, formula->u.formula );
	  fprintf( file, ")" );
	  break;
	case NOT_FORMULA:
	  fprintf( file, "(not " );
	  printFormula( file, formula->u.formula );
	  fprintf( file, ")" );
	  break;
	case UNKNOWN_FORMULA:
	  fprintf( file, "(unknown " );
	  printFormula( file, formula->u.formula );
	  fprintf( file, ")" );
	  break;
	case FORALL_FORMULA:
	case FORALL_EFFECT:
	  fprintf( file, "(forall (" );
	  for( idList_t *var = formula->u.lambda.vars; var != NULL; var = var->next )
	    fprintf( file, "%s%s", var->name, (var->next != NULL ? " " : "") );
	  fprintf( file, ") " );
	  printFormula( file, formula->u.lambda.formula );
	  fprintf( file, ")" );
	  break;
	case LIST_FORMULA:
	  fprintf( file, "[" );
	  for( f = formula; f != NULL; f = f->u.flist.next )
	    {
	      printFormula( file, f->u.flist.formula );
	      if( f->u.flist.next != NULL )
		fprintf( file, " " );
	    }
	  fprintf( file, "]" );
	  break;
	case EMPTY_FORMULA:
	  fprintf( file, ":empty:" );
	  break;
	case CERTAINTY_FORMULA:
	  fprintf( file, ":certainty:" );
	  break;
	case ADD_FORMULA:
	  fprintf( file, "(+ " );
	  printFormula( file, formula->u.formula );
	  fprintf( file, ")" );
	  break;
	case KNOW_FORMULA:
	  fprintf( file, "(know " );
	  printFormula( file, formula->u.formula );
	  fprintf( file, ")" );
	  break;
	case WHEN_EFFECT:
	  fprintf( file, "\n(when " );
	  printFormula( file, formula->u.when.formula );
	  fprintf( file, " " );
	  printFormula( file, formula->u.when.effect );
	  fprintf( file, ")" );
	  break;
	default:
	  printf( "parse(printFormula): unexpected formula type %d\n", formula->type );
	  break;
	}
    }
}


void
printFormulaPDDL( ostream& out, formula_t *formula )
{
  formula_t *f;
  if( formula == NULL )
    out << "(null)";
  else
    {
      switch( formula->type )
	{
	case ATOMIC_FORMULA:
	  printAtomicFormulaPDDL( out, formula );
	  break;
	case AND_FORMULA:
	  out << "(and ";
	  printFormulaPDDL( out, formula->u.formula );
	  out << ")";
	  break;
	case OR_FORMULA:
	  out << "(or ";
	  printFormulaPDDL( out, formula->u.formula );
	  out << ")";
	  break;
	case ONEOF_FORMULA:
	  out << "(oneof ";
	  printFormulaPDDL( out, formula->u.formula );
	  out << ")";
	  break;
	case NOT_FORMULA:
	  out << "(not ";
	  printFormulaPDDL( out, formula->u.formula );
	  out << ")";
	  break;
	case UNKNOWN_FORMULA:
	  out << "(unknown ";
	  printFormulaPDDL( out, formula->u.formula );
	  out << ")";
	  break;
	case FORALL_FORMULA:
	case FORALL_EFFECT:
	  out << "(forall (";
	  for( idList_t *var = formula->u.lambda.vars; var != NULL; var = var->next )
	    out << var->name << (var->next != NULL ? " " : "");
	  out << ") ";
	  printFormulaPDDL( out, formula->u.lambda.formula );
	  out << ")";
	  break;
	case LIST_FORMULA:
	  {
	    // out << "(and ";
	  for( f = formula; f != NULL; f = f->u.flist.next )
	    {
	      printFormulaPDDL( out, f->u.flist.formula );
	      if( f->u.flist.next != NULL )
		out << " ";
	    }
	  //out << ")";
	  }
	  break;
	case EMPTY_FORMULA:
	  out << ":empty:";
	  break;
	case CERTAINTY_FORMULA:
	  out << ":certainty:";
	  break;
	case ADD_FORMULA:
	  out << "(+ ";
	  printFormulaPDDL( out, formula->u.formula );
	  out << ")";
	  break;
	case KNOW_FORMULA:
	  out << "(know ";
	  printFormulaPDDL( out, formula->u.formula );
	  out << ")";
	  break;
	case WHEN_EFFECT:
	  out << "\n(when ";
	  printFormulaPDDL( out, formula->u.when.formula );
	  out << " ";
	  out << "(and ";
	  printFormulaPDDL( out, formula->u.when.effect );
	  out << ")";
	  out << ")";
	  break;
	default:
	  printf( "parse(printFormulaPDDL): unexpected formula type %d\n", formula->type );
	  break;
	}
    }
}

void
printFormulaPDDLTrans( ostream& out, formula_t *formula, string (*trans)(int) )
{
  formula_t *f;
  if( formula == NULL )
    out << "(null)";
  else
    {
      switch( formula->type )
	{
	case ATOMIC_FORMULA:
	  printAtomicFormulaPDDLTrans( out, formula, trans );
	  break;
	case AND_FORMULA:
	  out << "(and ";
	  printFormulaPDDLTrans( out, formula->u.formula, trans );
	  out << ")";
	  break;
	case OR_FORMULA:
	  out << "(or ";
	  printFormulaPDDLTrans( out, formula->u.formula, trans );
	  out << ")";
	  break;
	case ONEOF_FORMULA:
	  out << "(oneof ";
	  printFormulaPDDLTrans( out, formula->u.formula, trans );
	  out << ")";
	  break;
	case NOT_FORMULA:
	  out << "(not ";
	  printFormulaPDDLTrans( out, formula->u.formula, trans );
	  out << ")";
	  break;
	case UNKNOWN_FORMULA:
	  out << "(unknown ";
	  printFormulaPDDLTrans( out, formula->u.formula, trans );
	  out << ")";
	  break;
	case FORALL_FORMULA:
	case FORALL_EFFECT:
	  out << "(forall (";
	  for( idList_t *var = formula->u.lambda.vars; var != NULL; var = var->next )
	    out << var->name << (var->next != NULL ? " " : "");
	  out << ") ";
	  printFormulaPDDLTrans( out, formula->u.lambda.formula, trans );
	  out << ")";
	  break;
	case LIST_FORMULA:
	  {
	    // out << "(and ";
	  for( f = formula; f != NULL; f = f->u.flist.next )
	    {
	      printFormulaPDDLTrans( out, f->u.flist.formula, trans );
	      if( f->u.flist.next != NULL )
		out << " ";
	    }
	  //out << ")";
	  }
	  break;
	case EMPTY_FORMULA:
	  out << ":empty:";
	  break;
	case CERTAINTY_FORMULA:
	  out << ":certainty:";
	  break;
	case ADD_FORMULA:
	  out << "(+ ";
	  printFormulaPDDLTrans( out, formula->u.formula, trans );
	  out << ")";
	  break;
	case KNOW_FORMULA:
	  out << "(know ";
	  printFormulaPDDLTrans( out, formula->u.formula, trans );
	  out << ")";
	  break;
	case WHEN_EFFECT:
	  out << "\n(when ";
	  printFormulaPDDLTrans( out, formula->u.when.formula, trans );
	  out << " ";
	  out << "(and ";
	  printFormulaPDDLTrans( out, formula->u.when.effect, trans );
	  out << ")";
	  out << ")";
	  break;
	default:
	  printf( "parse(printFormulaPDDLTrans): unexpected formula type %d\n", formula->type );
	  break;
	}
    }
}

void
printInitialPDDL( ostream& out, formula_t *formula )
{
  formula_t *f;
  if( formula == NULL )
    out << "(null)";
  else
    {
      switch( formula->type )
	{
	case ATOMIC_FORMULA:
	  printAtomicFormulaPDDL( out, formula );
	  break;
	case AND_FORMULA:
	  out << "(and ";
	  printInitialPDDL( out, formula->u.formula );
	  out << ")";
	  break;
	case OR_FORMULA:
	  out << "(or ";
	  printInitialPDDL( out, formula->u.formula );
	  out << ")";
	  break;
	case ONEOF_FORMULA:
/* 	  out << "(oneof "; */
/* 	  printInitialPDDL( out, formula->u.formula ); */
/* 	  out << ")"; */
	  break;
	case NOT_FORMULA:
	  out << "(not ";
	  printInitialPDDL( out, formula->u.formula );
	  out << ")";
	  break;
	case UNKNOWN_FORMULA:
/* 	  out << "(unknown "; */
/* 	  printInitialPDDL( out, formula->u.formula ); */
/* 	  out << ")"; */
	  break;
	case FORALL_FORMULA:
	case FORALL_EFFECT:
	  out << "(forall (";
	  for( idList_t *var = formula->u.lambda.vars; var != NULL; var = var->next )
	    out << var->name << (var->next != NULL ? " " : "");
	  out << ") ";
	  printInitialPDDL( out, formula->u.lambda.formula );
	  out << ")";
	  break;
	case LIST_FORMULA:
	  {
	    // out << "(and ";
	  for( f = formula; f != NULL; f = f->u.flist.next )
	    {
	      printInitialPDDL( out, f->u.flist.formula );
	      if( f->u.flist.next != NULL )
		out << " ";
	    }
	  //out << ")";
	  }
	  break;
	case EMPTY_FORMULA:
	  out << ":empty:";
	  break;
	case CERTAINTY_FORMULA:
	  out << ":certainty:";
	  break;
	case ADD_FORMULA:
	  out << "(+ ";
	  printInitialPDDL( out, formula->u.formula );
	  out << ")";
	  break;
	case KNOW_FORMULA:
	  out << "(know ";
	  printInitialPDDL( out, formula->u.formula );
	  out << ")";
	  break;
	case WHEN_EFFECT:
	  out << "\n(when ";
	  printInitialPDDL( out, formula->u.when.formula );
	  out << " ";
	  out << "(and ";
	  printInitialPDDL( out, formula->u.when.effect );
	  out << ")";
	  out << ")";
	  break;
	default:
	  printf( "parse(printInitialPDDL): unexpected formula type %d\n", formula->type );
	  break;
	}
    }
}

bool
isSimpleFormula( formula_t* formula )
{
  if( formula == NULL ) return false;
  switch( formula->type )
    {
    case ATOMIC_FORMULA:
      return true;
      break;
    default:
      return false;
    }
}

bool
isDISJUNCTION( formula_t *formula, bool accept_or = false )
{
  if( formula == NULL )
    return false;
  else
    {
      switch( formula->type )
	{
	case ATOMIC_FORMULA:
	  return true;
	case OR_FORMULA:
	  if( !accept_or )
	    return false;
	case ONEOF_FORMULA:
	  {
	    formula_t* f = formula->u.formula;
	    bool val = true;
	    for( f = formula; f != NULL; f = f->u.flist.next )
	      val = val && isSimpleFormula( f->u.flist.formula );
	    return val;
	  }
	case UNKNOWN_FORMULA:
 	  return isSimpleFormula( formula->u.formula );

	case LIST_FORMULA:
	case AND_FORMULA:
	case NOT_FORMULA: // Not only for vars
	case FORALL_FORMULA:
	case FORALL_EFFECT:
	  return false;
	case EMPTY_FORMULA:
	case CERTAINTY_FORMULA:
	case ADD_FORMULA:
	case KNOW_FORMULA:
	case WHEN_EFFECT:
	default:
	  printf( "parse(isDISJUNCTION): unexpected formula type %d\n", formula->type );
	  exit(1);
	}
    }
}

bool
isCNF( formula_t *formula, bool accept_or = false )
{
  formula_t *f;
  if( formula == NULL )
    return false;
  else
    {
      switch( formula->type )
	{
	case LIST_FORMULA:
	  {
	    bool val = true;
	    for( f = formula; f != NULL; f = f->u.flist.next )
	      val = val && isDISJUNCTION( f->u.flist.formula, accept_or );
	    return val;
	  }
	case AND_FORMULA:
	  return isCNF( formula->u.formula, accept_or );
	case ATOMIC_FORMULA:
	case OR_FORMULA:
	case ONEOF_FORMULA:
	case UNKNOWN_FORMULA:
 	  return isDISJUNCTION( formula->u.formula, accept_or );

	case NOT_FORMULA: // Not only for vars
	case FORALL_FORMULA:
	case FORALL_EFFECT:
	  return false;
	case EMPTY_FORMULA:
	case CERTAINTY_FORMULA:
	case ADD_FORMULA:
	case KNOW_FORMULA:
	case WHEN_EFFECT:
	default:
	  printf( "parse(isCNF): unexpected formula type %d\n", formula->type );
	  exit(1);
	}
    }
}

int
getSimpleFormula( formula_t* formula )
{
  if( formula == NULL ) return 0;
  switch( formula->type )
    {
    case ATOMIC_FORMULA:
      if( !formula->u.atomic.equal )
	{
	  int atom = atomId( formula, NULL );
	  assert( atom > 0 ); // Atom doesn't exist
	  atom = (formula->u.atomic.neg?-1:1) * atom;
	  return atom;
	}
    default:
      printf( "parse(getSimpleFormula): unexpected formula type %d\n", formula->type );
      exit(1);
    }
}

// do not accept not({and|or} ..)
// neither (or ... )
static void
collectConjFormulaAtoms( formula_t* formula, int* parameters, std::set<int> &atoms )
{
  if( formula == NULL ) return;
  switch( formula->type )
    {
    case ATOMIC_FORMULA:
      if( !formula->u.atomic.equal )
	{
	  int atom = atomId( formula, parameters );
	  if( atom <= 0 ) return; // Atom doesn't exist
	  atom = (formula->u.atomic.neg?-1:1)*atom;
	  atoms.insert( atom );
	}
      break;
    case LIST_FORMULA:
      collectConjFormulaAtoms( formula->u.flist.formula, parameters, atoms );
      collectConjFormulaAtoms( formula->u.flist.next, parameters, atoms );
      break;

    case AND_FORMULA:
    case NOT_FORMULA: 
    case UNKNOWN_FORMULA:
    case ONEOF_FORMULA:
    case OR_FORMULA:
    default:
      printf( "parser(collectConjFormulaAtoms): unexpected formula type %d\n", formula->type );
      break;
    }
}

#ifdef USE_CLAUSE

void
getDISJUNCTION( formula_t *formula, clauses& c_or, clauses& c_oneof, 
		set<int>& literals, bool accept_or = false )
{
  formula_t *f;
  if( formula == NULL )
    return;
  else
    {
      switch( formula->type )
	{
	case ATOMIC_FORMULA:
	  {
	    int lit = getSimpleFormula(formula);
	    assert( lit != 0 );
	    literals.insert( lit );
	  }
	  break;
	case OR_FORMULA:
	  assert( accept_or );
	case ONEOF_FORMULA:
	  {
	    formula_t* f = formula->u.formula;
	    clause c;
	    collectConjFormulaAtoms( f, NULL, c );
	    if( formula->type == ONEOF_FORMULA )
	      c_oneof.insert(c);
	    else
	      c_or.insert(c);
	    break;
	    for( f = formula; f != NULL; f = f->u.flist.next )
	      {
		int lit = getSimpleFormula( f->u.flist.formula );
		assert( lit != 0 );
		c.insert(lit);
	      }
	  }
	  break;
	case UNKNOWN_FORMULA:
	  break;
	case LIST_FORMULA:
	  {
	    formula_t* f = formula->u.formula;
	    for( f = formula; f != NULL; f = f->u.flist.next )
	      getDISJUNCTION( f->u.flist.formula, c_or, c_oneof, literals, accept_or );
	  }
	  break;

	case AND_FORMULA:
	case NOT_FORMULA: // Not only for vars
	case FORALL_FORMULA:
	case FORALL_EFFECT:
	case EMPTY_FORMULA:
	case CERTAINTY_FORMULA:
	case ADD_FORMULA:
	case KNOW_FORMULA:
	case WHEN_EFFECT:
	default:
	  printf( "parse(getDISJUNCTION): unexpected formula type %d\n", formula->type );
	  exit(1);
	}
    }
}

void
getCNF( formula_t *formula, clauses& c_or, clauses& c_oneof, set<int>& literals, bool accept_or = false )
{
  formula_t *f;
  if( formula == NULL )
    return;
  else
    {
      switch( formula->type )
	{
	case LIST_FORMULA:
	  for( f = formula; f != NULL; f = f->u.flist.next )
	    getCNF( f->u.flist.formula, c_or, c_oneof, literals, accept_or );
	  break;
	case AND_FORMULA:
	  getCNF( formula->u.formula, c_or, c_oneof, literals, accept_or );
	  break;
	case ATOMIC_FORMULA:
	case OR_FORMULA:
	case ONEOF_FORMULA:
	case UNKNOWN_FORMULA:
	  getDISJUNCTION( formula, c_or, c_oneof, literals, accept_or );
	  break;

	case NOT_FORMULA: // Not only for vars
	case FORALL_FORMULA:
	case FORALL_EFFECT:
	case EMPTY_FORMULA:
	case CERTAINTY_FORMULA:
	case ADD_FORMULA:
	case KNOW_FORMULA:
	case WHEN_EFFECT:
	default:
	  printf( "parse(getCNF): unexpected formula type %d\n", formula->type );
	  exit(1);
	}
    }
}

#endif

void
collectFormulaUncertainty( formula_t *formula, std::vector<formula_t*>& formulas )
{
  formula_t *f;
  if( formula != NULL )
    {
      switch( formula->type )
	{
	case EMPTY_FORMULA:
	case CERTAINTY_FORMULA:
	case ATOMIC_FORMULA:
	  // discard
	  break;
	case AND_FORMULA:
	  collectFormulaUncertainty( formula->u.formula, formulas );
	  break;
	case ONEOF_FORMULA:
	case OR_FORMULA:
	  for( f = formula->u.formula; f != NULL; f = f->u.flist.next )
	    if(!isSimpleFormula( f->u.flist.formula ))
	      {
		printf( "ERROR: collectFormulaUncertainty: complex formula inside ONEOF or OR\n");
		exit(1);
	      }
	  formulas.push_back( formula );
	  break;
	case UNKNOWN_FORMULA:
	  // CFF benchmarks includes unknown for every unknown atom
	  // instead follow conformant planning competition 2006
	  formulas.push_back( formula );
	  break;
	case LIST_FORMULA:
	  for( f = formula; f != NULL; f = f->u.flist.next )
	    collectFormulaUncertainty( f->u.flist.formula, formulas );
	  break;
	case FORALL_FORMULA:
	case FORALL_EFFECT:
	case ADD_FORMULA:
	case WHEN_EFFECT:
	case KNOW_FORMULA:
	case NOT_FORMULA: // Not of atoms are atoms. Other NOT are not allowed
	default:
	  printf( "ERROR: collectFormulaUncertainty: unexpected formula type %d\n", formula->type );
	  exit(1);
	}
    }
}

void
printSchema( FILE *file, schema_t *schema )
{
  fprintf( file, "BEGIN-SCHEMA %s:\n", schema->name );
  fprintf( file, "  PARAMETERS = " );
  for( idList_t *id = schema->vars; id != NULL; id = id->next )
    fprintf( file, "%s ", id->name );
  fprintf( file, "\n  PRECONDITION = " );
  printFormula( file, schema->prec );
  fprintf( file, "\n  EFFECT = " );
  printFormula( file, schema->effect );
  fprintf( file, "\nEND-SCHEMA\n" );
}


static void
generateNames( void )
{
  str2wff_t::iterator it;
  map<const char*,idList_t*,ltstr>::iterator it2;

  _low_schemaName = (char**)calloc( _low_numberSchema, sizeof( char* ) );
  _low_objectName = (char**)calloc( numberObjects, sizeof( char* ) );
  _low_predicateName = (char**)calloc( _low_numberPredicates, sizeof( char* ) );

  for( int i = 0; i < _low_numberSchema; ++i )
    _low_schemaName[i] = strdup( _low_schemaTable[i]->name );

  for( it = predicates.begin(); it != predicates.end(); ++it )
    {
      _low_predicateName[(*it).second->u.atomic.id-1] = strdup( (*it).second->u.atomic.name );
      //xxxx printf( "name for p%d = \"%s\"\n", (*it).second->u.atomic.id, (*it).second->u.atomic.name );
    }

  for( it2 = objects.begin(); it2 != objects.end(); ++it2 )
    _low_objectName[(*it2).second->id-1] = strdup( (*it2).second->name );
}

vector<formula_t* > later_formula;
vector<idList_t *> later_object;


// Rescue unbounded predicates and objects
void
rescue_later()
{
  for( vector<formula_t*>::iterator it3 = later_formula.begin(); it3 != later_formula.end(); ++it3 )
    {
      formula_t* formula = *it3;
      str2wff_t::iterator it =
	predicates.find( formula->u.atomic.name );
      if( it == predicates.end() )
	{
	  printf( "FALTAL: parser(idMatchArgsVars): no predicate for %s\n", formula->u.atomic.name );
	  exit(1);
	}
      else
	{
	  formula->u.atomic.id = (*it).second->u.atomic.id;
	  formula->u.atomic.equal = (*it).second->u.atomic.equal;
	}	
    }
  for( vector<idList_t*>::iterator it3 = later_object.begin(); it3 != later_object.end(); ++it3 )
    {
      idList_t *arg = *it3;
      map<const char*,idList_t*,ltstr>::iterator it2 = 
	objects.find( arg->name );
      if( it2 == objects.end() )
	{
	  printf( "FATAL: parser(idMatchArgsVars): no object for %s\n", arg->name );
	  exit(1);
	}
      else
	arg->id = (*it2).second->id;
    }
}

static void
idMatchArgsVars( formula_t *formula, idList_t *vars )
{
  idList_t *arg, *var;
  str2wff_t::iterator it;
  map<const char*,idList_t*,ltstr>::iterator it2;

  if( formula != NULL )
    switch( formula->type )
      {
      case ATOMIC_FORMULA:
	for( str2wff_t::iterator it3 = predicates.begin(); 
	     it3 != predicates.end(); 
	     it3++ )
	  assert( it3->first != 0 );
	assert( formula->u.atomic.name != 0 );
	it = predicates.find( formula->u.atomic.name );
	if( it == predicates.end() )
	  {
	    printf( "parser(idMatchArgsVars): no predicate for %s\n", formula->u.atomic.name );
	    later_formula.push_back( formula );
	  }
	else
	  {
	    formula->u.atomic.id = (*it).second->u.atomic.id;
	    formula->u.atomic.equal = (*it).second->u.atomic.equal;
	  }

	for( arg = formula->u.atomic.args; arg != NULL; arg = arg->next )
	  if( arg->name[0] == '?' )
	    {
	      for( var = vars; var != NULL; var = var->next )
		if( !strcasecmp( arg->name, var->name ) )
		  {
		    arg->id = var->id;
		    break;
		  }
	      if( var == NULL )
		printf( "parser(idMatchArgsVars): no variable for %s\n", arg->name );
	    }
	  else
	    {
	      it2 = objects.find( arg->name );
	      if( it2 == objects.end() )
		{ 
		  printf( "parser(idMatchArgsVars): no object for %s\n", arg->name );
		  later_object.push_back( arg );
		  if(0){
		  cout << "Objects: ";
		  for( it2 = objects.begin(); it2 != objects.end(); ++it2 )
		    cout<< it2->second->name << " ";
		  cout << endl;
		  }
		}
	      else
		arg->id = (*it2).second->id;
	    }
	break;
      case AND_FORMULA:
      case OR_FORMULA:
      case NOT_FORMULA:
      case ADD_FORMULA:
      case KNOW_FORMULA:
      case ONEOF_FORMULA:
      case UNKNOWN_FORMULA:
	idMatchArgsVars( formula->u.formula, vars );
	break;
      case FORALL_FORMULA:
      case FORALL_EFFECT:
	// extend environment and make recursive call
	for( var = formula->u.lambda.vars; var->next != NULL; var = var->next );
	assert( (var != NULL) && (var->next == NULL) );
	var->next = vars;
	idMatchArgsVars( formula->u.lambda.formula, formula->u.lambda.vars );
	var->next = NULL;
	break;
      case LIST_FORMULA:
	idMatchArgsVars( formula->u.flist.formula, vars );
	idMatchArgsVars( formula->u.flist.next, vars );
	break;
      case EMPTY_FORMULA:
      case CERTAINTY_FORMULA:
	break;
      case SET_FORMULA:
	idMatchArgsVars( formula->u.fset.literal, vars );
	idMatchArgsVars( formula->u.fset.formula, vars );
	break;
      case WHEN_EFFECT:
	idMatchArgsVars( formula->u.when.formula, vars );
	idMatchArgsVars( formula->u.when.effect, vars );
	break;
      default:
	printf( "parse(idMatchArgsVars): unexpected formula type %d\n", formula->type );
	break;
      }
}

static bool
isOfType( idList_t *type1, idList_t *type2 )
{
  if( type1 == NULL && type2 == NULL )
    return true;
  if( type1 == NULL || type2 == NULL )
    return false;
  if( !strcasecmp( type1->name, type2->name ) )
    return( true );
  else
    {
      map<const char*,idList_t*,ltstr>::iterator it;
      for( idList_t *t1 = type1; t1 != NULL; t1 = t1->next )
	if( (it = types.find( t1->name )) != types.end() )
	  {
	      for( idList_t *t2 = (*it).second->type; t2 != NULL; t2 = t2->next )
		if( isOfType( t2, type2 ) )
		  return( true );
	    }
      return( false );
    }
}

static instantiation_t *
buildInstantiation( idList_t *vars, idList_t *args )
{
  if( !vars && !args )
    {
      return( NULL );
    }
  else if( vars && args )
    {
      instantiation_t *inst = (instantiation_t*)malloc( sizeof( instantiation_t ) );
      inst->var = vars;
      inst->val = args;
      inst->next = buildInstantiation( vars->next, args->next );
      return( inst );
    }
  else
    {
      printf( "parse(buildInstantiation): wrong number or arguments\n" );
      return( NULL );
    }
}

static formula_t *
copyReplaceAtomicFormula( formula_t *formula, instantiation_t *instantiation )
{
  instantiation_t *inst;
  idList_t *arg, *prevArg, *newArg;

  formula_t *result = (formula_t*)malloc( sizeof( formula_t ) );
  *result = *formula;
  result->u.atomic.args = NULL;

  // copy/replace arguments
  prevArg = NULL;
  for( arg = formula->u.atomic.args; arg != NULL; arg = arg->next )
    {
      newArg = (idList_t*)malloc( sizeof( idList_t ) );
      for( inst = instantiation; inst != NULL; inst = inst->next )
	if( !strcasecmp( arg->name, inst->var->name ) )
	  break;
      *newArg = *(inst==NULL?arg:inst->val);
      newArg->next = NULL;

      // link it
      if( prevArg == NULL )
	result->u.atomic.args = newArg;
      else
	prevArg->next = newArg;
      prevArg = newArg;
    }
  return( result );
}

static formula_t *
copyReplaceFormula( formula_t *formula, instantiation_t *inst )
{
  formula_t *result = NULL;
  if( formula != NULL )
    {
      switch( formula->type )
	{
	case ATOMIC_FORMULA:
	  result = copyReplaceAtomicFormula( formula, inst );
	  break;
	case AND_FORMULA:
	case OR_FORMULA:
	case NOT_FORMULA:
	case ADD_FORMULA:
	case KNOW_FORMULA:
	case ONEOF_FORMULA:
	case UNKNOWN_FORMULA:
	  result = (formula_t*)malloc( sizeof( formula_t ) );
	  *result = *formula;
	  result->u.formula = copyReplaceFormula( formula->u.formula, inst );
	  break;
	case FORALL_FORMULA:
	case FORALL_EFFECT:
	  result = (formula_t*)malloc( sizeof( formula_t ) );
	  *result = *formula;
	  result->u.lambda.formula = copyReplaceFormula( formula->u.lambda.formula, inst );
	  break;
	case LIST_FORMULA:
	  result = (formula_t*)malloc( sizeof( formula_t ) );
	  *result = *formula;
	  result->u.flist.formula = copyReplaceFormula( formula->u.flist.formula, inst );
	  result->u.flist.next = copyReplaceFormula( formula->u.flist.next, inst );
	  break;
	default:
	  result = formula;
	  break;
	}
    }
  return( result );
}

static formula_t *
instantiateFormula( formula_t* formula, idList_t* vars, instantiation_t* inst, formula_t *result )
{
  map<const char*,idList_t*,ltstr>::iterator it;
  if( vars == NULL )
    {
      formula_t *aux = (formula_t*)malloc( sizeof( formula_t ) );
      aux->type = LIST_FORMULA;
      aux->u.flist.formula = unfoldQuantifiers( copyReplaceFormula( formula, inst ) );
      aux->u.flist.next = result;
      result = aux;
    }
  else
    {
      instantiation_t newInst;
      newInst.next = inst;
      newInst.var = vars;
      for( it = objects.begin(); it != objects.end(); ++it )
	if( isOfType( (*it).second->type, vars->type ) )
	  {
	    newInst.val = (*it).second;
	    result = instantiateFormula( formula, vars->next, &newInst, result );
	  }
    }
  return( result );
}

static formula_t *
unfoldQuantifiers( formula_t *formula )
{
  formula_t *result = NULL;
  if( formula != NULL )
    {
      result = formula;
      switch( formula->type )
	{
	case ATOMIC_FORMULA:
	  break;
	case AND_FORMULA:
	case OR_FORMULA:
	case NOT_FORMULA:
	case ADD_FORMULA:
	case KNOW_FORMULA:
	case ONEOF_FORMULA:
	case UNKNOWN_FORMULA:
	  result->u.formula = unfoldQuantifiers( formula->u.formula );
	  break;
	case FORALL_FORMULA:
	case FORALL_EFFECT:
	  result = (formula_t*)malloc( sizeof( formula_t ) );
	  result->type = AND_FORMULA;
	  result->u.formula = instantiateFormula( formula->u.lambda.formula, formula->u.lambda.vars, NULL, NULL );
	  break;
	case LIST_FORMULA:
	  result->u.flist.formula = unfoldQuantifiers( result->u.flist.formula );
	  result->u.flist.next = unfoldQuantifiers( result->u.flist.next );
	  break;
	case SET_FORMULA:
	  result->u.fset.formula = unfoldQuantifiers( formula->u.fset.formula );
	  break;
	case WHEN_EFFECT:
	  result->u.when.formula = unfoldQuantifiers( formula->u.when.formula );
	  result->u.when.effect = unfoldQuantifiers( formula->u.when.effect );
	  break;
	default:
	  printf( "parse(unfoldQuantifiers): unexpected formula type %d\n", formula->type );
	  break;
	}
    }
  return( result );
}

static formula_t *
linearizeEffect( formula_t *formula, formula_t* &tail )
{
  formula_t *aux, *result;
  result = tail = NULL;
  if( formula != NULL )
    switch( formula->type )
      {
      case ATOMIC_FORMULA:
      case EMPTY_FORMULA:
      case SET_FORMULA:
      case WHEN_EFFECT:
	result = (formula_t*)malloc( sizeof( formula_t ) );
	result->type = LIST_FORMULA;
	result->u.flist.formula = formula;
	result->u.flist.next = NULL;
	tail = result;
	break;
      case AND_FORMULA:
	result = linearizeEffect( formula->u.formula, tail );
	break;
      case LIST_FORMULA:
	result = linearizeEffect( formula->u.flist.formula, aux );
	aux->u.flist.next = linearizeEffect( formula->u.flist.next, tail );
	if( tail == NULL )
	  tail = aux;
	break;
      default:
	printf( "parse(linearizeEffect): unexpected formula type %d\n", formula->type );
	break;
      }
  return( result );
}

// return -1 if parameters are not instantiated
static int
atomId( formula_t *literal, int* parameters )
{
  static int arguments[MAXPARAMETERS];

  // argument extraction
  int *p = arguments;
  *p++ = literal->u.atomic.id;
  for( idList_t *arg = literal->u.atomic.args; arg != NULL; arg = arg->next )
    if( arg->name[0] == '?' )
      {
	assert( arg->id > 0 );
	if( parameters[arg->id] <= 0 )
	  return -1; // Atom does not exist
	*p++ = parameters[arg->id];
      }
    else
      *p++ = arg->id;
  *p = -1;

  // generate atomId
  return( readAtomHash( arguments )->idx );
}


void
generateAtoms( void )
{
  formula_t *formula;
  str2wff_t::iterator it;

  for( it = predicates.begin(); it != predicates.end(); ++it )
    if( (*it).second->u.atomic.equal == 0 )
      {
	// generate instantiations and insert into atom hash
	formula = instantiateFormula( (*it).second, (*it).second->u.atomic.args, NULL, NULL );
	while( formula != NULL )
	  {
	    atomId( formula->u.flist.formula, NULL );
	    formula = formula->u.flist.next;
	  }
      }
}

void
generateVarsAndValues( void )
{
  int i, j, k;
  idList_t *var;
  map<const char*,idList_t*,ltstr>::iterator it;

  // vars
  _low_vars = (int**)calloc( _low_numberSchema, sizeof( int* ) );
  for( i = 0; i < _low_numberSchema; ++i )
    {
      _low_vars[i] = (int*)calloc( maxParameters + 1, sizeof( int ) );
      for( var = _low_schemaTable[i]->vars, j = 0; var != NULL; var = var->next, ++j )
	_low_vars[i][j] = var->id;
    }

  // values
  _low_values = (int**)calloc( _low_numberSchema * (maxParameters + 1), sizeof( int* ) );
  for( i = 0; i < _low_numberSchema * maxParameters; ++i )
    _low_values[i] = (int*)calloc( numberObjects+1, sizeof( int ) );
  for( i = 0; i < _low_numberSchema; ++i )
    for( var = _low_schemaTable[i]->vars; var != NULL; var = var->next )
      {
	k = 0;
	if( var->type == NULL )
	  {
	    for( it = objects.begin(); it != objects.end(); ++it )
	      _low_values[_low_numberSchema*(var->id-1) + i][k++] = (*it).second->id;
	  }
	else
	  {
	    if( !(_low_requirements & REQ_TYPING) )
	      printf( "parser(generateVarsAndValues): using types without :typing requirements.\n" );
	    for( it = objects.begin(); it != objects.end(); ++it )
	      if( !strcasecmp( var->type->name, (*it).second->type->name ) ||
		  isOfType( (*it).second->type, var->type ) )
		_low_values[_low_numberSchema*(var->id-1) + i][k++] = (*it).second->id;
	  }
      }
}

static nnf::node
generateEffect( nnf::Manager *man, nnf::node avar, formula_t *formula, int *parameters, lit_effect_t &frame )
{
  nnf::node res, tmp1, tmp2, tmp3;
  lit_effect_t t_frame;
  assert( (avar != (unsigned)-1) || (formula->type != WHEN_EFFECT) );

  switch( formula->type )
    {
    case LIST_FORMULA:
      res = nnf::make_value( man, true );
      for( formula_t *eff = formula; eff != 0; eff = eff->u.flist.next )
	{
	  tmp1 = generateEffect( man, avar, eff->u.flist.formula, parameters, frame );
	  tmp2 = nnf::make_and( man, res, tmp1 );
	  man->unregister_use( res );
	  man->unregister_use( tmp1 );
	  res = tmp2;
	}
      break;
    case ATOMIC_FORMULA:
      // CNF = action => lit = -action || lit
      tmp1 = generateAtomicFormula( man, formula, parameters, true );
      if( avar != (unsigned)-1 )
	res = nnf::make_or( man, avar, tmp1 );
      else
	{
	  res = tmp1;
	  man->register_use( tmp1 );
	}
      frame.push_back( std::make_pair( (formula_t*)0, std::make_pair( nnf::make_value(man,true), tmp1 ) ) );
      break;
    case SET_FORMULA:
      assert( 0 );
      break;
    case WHEN_EFFECT:
      // CNF:  action & condition => lit  <=>  -action || -condition || lit
      tmp1 = generateFormula( man, formula->u.when.formula, parameters, false );
      tmp2 = nnf::make_not( man, tmp1 );
      tmp3 = nnf::make_or( man, avar, tmp2 );
      man->unregister_use( tmp2 );
      tmp2 = generateEffect( man, (unsigned)-1, formula->u.when.effect, parameters, t_frame );
      res = nnf::make_or( man, tmp3, tmp2 );
      man->unregister_use( tmp3 );
      man->unregister_use( tmp2 );
      tmp2 = nnf::make_cnf( man, res );
      man->unregister_use( res );
      res = tmp2;
      for( size_t i = 0; i < t_frame.size(); ++i )
	{
	  man->register_use( tmp1 );
	  frame.push_back( std::make_pair( formula->u.when.formula, std::make_pair(tmp1,t_frame[i].second.second) ) );
	  man->unregister_use( t_frame[i].second.first );
	}
      man->unregister_use( tmp1 );
      break;
    default:
      res = nnf::make_value( man, true );
      printf( "parse(generateEffect): unexpected formula type %d\n", formula->type );
      break;
    }
  return( res );
}

static void
collectEffectAtoms( formula_t *formula, int *parameters, std::vector<int> &atoms, std::vector<int> *atoms_conds )
{
  switch( formula->type )
    {
    case LIST_FORMULA:
      for( formula_t *eff = formula; eff != 0; eff = eff->u.flist.next )
	collectEffectAtoms( eff->u.flist.formula, parameters, atoms, atoms_conds );
      break;
    case ATOMIC_FORMULA:
      collectFormulaAtoms( formula, parameters, atoms );
      break;
    case WHEN_EFFECT:
      if( atoms_conds )
	collectFormulaAtoms( formula->u.when.formula, parameters, *atoms_conds );
      collectEffectAtoms( formula->u.when.effect, parameters, atoms, atoms_conds );
      break;
    default:
      printf( "parse(collectEffectAtoms): unexpected formula type %d\n", formula->type );
      break;
    }
}

static void
collectUncondEffectAtoms( formula_t *formula, int *parameters, std::vector<int> &atoms )
{
  switch( formula->type )
    {
    case LIST_FORMULA:
      for( formula_t *eff = formula; eff != 0; eff = eff->u.flist.next )
	collectUncondEffectAtoms( eff->u.flist.formula, parameters, atoms );
      break;
    case ATOMIC_FORMULA:
      collectFormulaAtoms( formula, parameters, atoms );
      break;
    case AND_FORMULA:
      collectUncondEffectAtoms( formula->u.formula, parameters, atoms );
      printf( "CHECK: pass through AND in collectEffectAtoms\n" );
      break;
    case SET_FORMULA:
      assert( 0 );
      break;
    case WHEN_EFFECT:
      break;
    default:
      printf( "parse(collectEffectAtoms): unexpected formula type %d\n", formula->type );
      break;
    }
}
void
mapWhenEffects( formula_t *formula, int *parameters, std::vector<formula_t*> &clist )
{
  switch( formula->type )
    {
    case LIST_FORMULA:
      for( formula_t *eff = formula; eff != 0; eff = eff->u.flist.next )
	mapWhenEffects( eff->u.flist.formula, parameters, clist );
      break;
    case ATOMIC_FORMULA:
      break;
    case SET_FORMULA:
      assert( 0 );
      break;
    case WHEN_EFFECT:
      clist.push_back( formula->u.when.formula );
      mapWhenEffects( formula->u.when.effect, parameters, clist );
      break;
    default:
      printf("parse(mapWhenEffects): unexpected formula type %d\n", formula->type);
      break;
    }
}

int
equalityValue( formula_t *formula, int *parameters )
{
  int val[2];
  idList_t *arg[2];
  arg[0] = formula->u.atomic.args;
  arg[1] = formula->u.atomic.args->next;
  for( int i = 0; i < 2; ++i )
    {
      if( arg[i]->name[0] == '?' )
	{
	  assert( arg[i]->id > 0 );
	  if( parameters[arg[i]->id] <= 0 )
	    return -1; // Atom does not exist
	  val[i] = parameters[arg[i]->id];
	}
      else
	val[i] = arg[i]->id;
    }
  return( val[0] == val[1] );
}

static nnf::node
generateAtomicFormula( nnf::Manager *man, formula_t *formula, int *parameters, bool future )
{
  if( formula->u.atomic.equal == 1 )
    {
      bool test = equalityValue( formula, parameters );
      if( formula->u.atomic.neg ) test = !test;
      return( nnf::make_value( man, (test?true:false) ) );
    }
  else
    {
      int atom = atomId( formula, parameters );
      if( reachable.find( atom ) == reachable.end() )
	return( nnf::make_value( man, true ) ); // can only happen if formula is init
      else
	{
	  atom = reachable[atom];
	  atom = (future?atom+time_shift:atom)<<1; // present or future?
	  atom = (formula->u.atomic.neg?1+atom:atom);
	  return( nnf::make_variable( man, atom ) );
	}
    }
}

nnf::node
generateFormula( nnf::Manager *man, formula_t* formula, int* parameters, bool future )
{
  nnf::node res, tmp1, tmp2;
  if( formula == NULL ) return( nnf::make_value( man, true ) );
  switch( formula->type )
    {
    case ATOMIC_FORMULA:
      res = generateAtomicFormula( man, formula, parameters, future );
      break;
    case OR_FORMULA:
    case AND_FORMULA:
      res = nnf::make_value( man, (formula->type!=OR_FORMULA) );
      for( formula_t *f = formula->u.formula; f != NULL; f = f->u.flist.next )
	{
	  tmp1 = generateFormula( man, f->u.flist.formula, parameters, future );
	  if( formula->type == OR_FORMULA )
	    tmp2 = nnf::make_or( man, res, tmp1 );
	  else
	    tmp2 = nnf::make_and( man, res, tmp1 );
	  man->unregister_use( res );
	  man->unregister_use( tmp1 );
	  res = tmp2;
	}
      break;
    case LIST_FORMULA: // Verify it
      res = nnf::make_value( man, true );
      for( formula_t *f = formula; f != 0; f = f->u.flist.next ) 
	{
	  tmp1 = generateFormula( man, f->u.flist.formula, parameters, future );
	  tmp2 = nnf::make_and( man, res, tmp1 );
	  man->unregister_use( res );
	  man->unregister_use( tmp1 );
	  res = tmp2;
	}
      break;
    case NOT_FORMULA:
      tmp1 = generateFormula( man, formula->u.formula, parameters, future );
      res = nnf::make_not( man, tmp1 );
      man->unregister_use( tmp1 );
      break;
      // OJO: COMPLETAR!
    case ONEOF_FORMULA:
    case UNKNOWN_FORMULA:
      res = nnf::make_value( man, true );
      printf( "don't generate formula for ONEOF or UNKNOWN yet. Type %d\n", formula->type );
      break;
    default:
      res = nnf::make_value( man, true );
      printf( "parser(generateFormula): unexpected formula type %d\n", formula->type );
      //assert( 0 != 0 );
      break;
    }
  return( res );
}

static void
collectFormulaEquals( formula_t* formula, int* parameters, std::vector<formula_t*> &equals )
{
  if( formula == NULL ) return;
  switch( formula->type )
    {
    case ATOMIC_FORMULA:
      if( formula->u.atomic.equal )
	equals.push_back(formula);
      break;
    case AND_FORMULA:
      for( formula_t *f = formula->u.formula; f != NULL; f = f->u.flist.next )
	collectFormulaEquals( f->u.flist.formula, parameters, equals );
      break;
    case NOT_FORMULA:
      collectFormulaEquals( formula->u.formula, parameters, equals );
      break;
    case LIST_FORMULA:
      collectFormulaEquals( formula->u.flist.formula, parameters, equals );
      collectFormulaEquals( formula->u.flist.next, parameters, equals );
      break;
    case UNKNOWN_FORMULA:
    case OR_FORMULA:
    case ONEOF_FORMULA:
    default:
      printf( "parser(collectFormulaEquals): unexpected formula type %d\n", formula->type );
      break;
    }
}

// Collect atom already instantiated
static void
collectFormulaAtoms( formula_t* formula, int* parameters, std::vector<int> &atoms )
{
  if( formula == NULL ) return;
  switch( formula->type )
    {
    case ATOMIC_FORMULA:
      if( !formula->u.atomic.equal )
	{
	  int atom = atomId( formula, parameters );
	  if( atom <= 0 ) return; // Atom doesn't exist
	  atom = (formula->u.atomic.neg?1+(atom<<1):(atom<<1));
	  atoms.push_back( atom );
	}
      break;
    case OR_FORMULA:
    case AND_FORMULA:
    case ONEOF_FORMULA:
      for( formula_t *f = formula->u.formula; f != NULL; f = f->u.flist.next )
	collectFormulaAtoms( f->u.flist.formula, parameters, atoms );
      break;
    case UNKNOWN_FORMULA:
      collectFormulaAtoms( formula->u.formula, parameters, atoms );
      break;
    case LIST_FORMULA:
      collectFormulaAtoms( formula->u.flist.formula, parameters, atoms );
      collectFormulaAtoms( formula->u.flist.next, parameters, atoms );
      break;
    case NOT_FORMULA:
    default:
      printf( "parser(collectFormulaAtoms): unexpected formula type %d\n", formula->type );
      break;
    }
}

void
collectAllAtoms( formula_t* formula, int* parameters, std::vector<int> &atoms )
{
  if( formula == NULL ) return;
  switch( formula->type )
    {
    case LIST_FORMULA:
      for( formula_t *f = formula; f != 0; f = f->u.flist.next )
	collectAllAtoms( f->u.flist.formula, parameters, atoms );
      break;
    case ATOMIC_FORMULA:
      if( !formula->u.atomic.equal )
	{
	  int atom = atomId( formula, parameters );
	  atom = (formula->u.atomic.neg?1+(atom<<1):(atom<<1));
	  atoms.push_back( atom );
	}
      break;
    case OR_FORMULA:
    case AND_FORMULA:
    case ONEOF_FORMULA:
      for( formula_t *f = formula->u.formula; f != NULL; f = f->u.flist.next )
	collectAllAtoms( f->u.flist.formula, parameters, atoms );
      break;
    case NOT_FORMULA:
    case UNKNOWN_FORMULA:
      collectAllAtoms( formula->u.formula, parameters, atoms );
      break;
    case SET_FORMULA:
      assert( 0 );
      break;
    case WHEN_EFFECT:
      collectAllAtoms( formula->u.when.formula, parameters, atoms );
      collectAllAtoms( formula->u.when.effect, parameters, atoms );
      break;
    default:
      printf( "parser(collectAllAtoms): unexpected formula type %d\n", formula->type );
      break;
    }
}

void
generateSchema( nnf::Manager *man, nnf::node action, schema_t* schema, int* parameters )
{
  // need to generate cnfs for precondition and effects (frame will do elsewhere)
  // ASSUMPTION: avar is negative action literal 

  // CNF(prec) = prec || !action
  // ASSUMPTION: precondition formula is in positive form
  nnf::node tmp1 = generateFormula( man, schema->prec, parameters, false );
  nnf::node tmp2 = nnf::make_or( man, action, tmp1 );
  man->unregister_use( tmp1 );
  nnf::node prec = nnf::make_cnf( man, tmp2 );
  man->unregister_use( tmp2 );

  // cnf for effectstrue if action is 
  _low_operator.frame_->clear();
  nnf::node effect = generateEffect( man, action, schema->effect, parameters, *_low_operator.frame_ );
  tmp1 = nnf::make_and( man, prec, effect );
  man->unregister_use( prec );
  man->unregister_use( effect );
  _low_operator.cnf_ = tmp1;
}

// Return false can't be executed (typically, equals on precods)
// Return only atoms instatiated by parameters
bool
operatorAtoms( schema_t *schema, int *parameters, 
	       std::set<int> &prec, std::set<int> &add, std::set<int> &del,
	       std::set<int>* reachable_atoms = 0, 
	       std::set<int>* neg_prec = 0,  
	       std::set<int>* conds = 0 )
{
  std::vector<int> atoms_vec;
  collectPlainFormulaAtoms( schema->prec, parameters, atoms_vec );
  for( size_t i = 0; i < atoms_vec.size(); ++i )
    {
      if( atoms_vec[i] % 2 ) 
	{
	  if( reachable_atoms != 0 &&
	      reachable_atoms->count( atoms_vec[i] >> 1 ) )
	    return false;
	  if(neg_prec != 0) neg_prec->insert( atoms_vec[i] >> 1 );
	}
      else
	prec.insert( atoms_vec[i] >> 1 );
    }

  // Check if equals agree...
  std::vector<formula_t*> equals;
  collectFormulaEquals( schema->prec, parameters, equals );
  for( size_t i = 0; i < equals.size(); ++i )
    {
      assert( equals[i]->type = ATOMIC_FORMULA &&
	      equals[i]->u.atomic.equal == 1 );
      int test = equalityValue( equals[i], parameters );
      if( test != -1 )
	{
	  if( equals[i]->u.atomic.neg ) test = !test;
	  if( !test )
	    return false;
	}
    }
    
  atoms_vec.clear();
  vector<int> atoms_conds;
  if( conds )
    collectEffectAtoms( schema->effect, parameters, atoms_vec, &atoms_conds );    
  else
    collectEffectAtoms( schema->effect, parameters, atoms_vec );
  for( size_t i = 0; i < atoms_vec.size(); ++i )
    {
      if( atoms_vec[i] % 2 )
	del.insert( atoms_vec[i]>>1 );
      else
	add.insert( atoms_vec[i]>>1 );
    }
  if(conds)
    for( size_t i = 0; i < atoms_conds.size(); ++i )
      {
	if( atoms_conds[i] % 2 )
	  conds->insert( -int(atoms_conds[i]>>1) );
	else
	  conds->insert( atoms_conds[i]>>1 );
      }
  return true;
}



// do not accept not({and|or} ..)
// neither (or ... )
static void
collectPlainFormulaAtoms( formula_t* formula, int* parameters, std::vector<int> &atoms )
{
  if( formula == NULL ) return;
  switch( formula->type )
    {
    case ATOMIC_FORMULA:
      if( !formula->u.atomic.equal )
	{
	  int atom = atomId( formula, parameters );
	  if( atom <= 0 ) return; // Atom doesn't exist
	  atom = (formula->u.atomic.neg?1+(atom<<1):(atom<<1));
	  atoms.push_back( atom );
	}
      break;
    case AND_FORMULA:
      for( formula_t *f = formula->u.formula; f != NULL; f = f->u.flist.next )
	collectPlainFormulaAtoms( f->u.flist.formula, parameters, atoms );
      break;
    case NOT_FORMULA: 
      if ( formula->u.formula->type != ATOMIC_FORMULA )
	{
	  printf( "parser(collectPlainFormulaAtoms): not of a non atomic formula\n");
	  exit(1);
	}
      collectPlainFormulaAtoms( formula->u.formula, parameters, atoms );
      break;
    case LIST_FORMULA:
      collectPlainFormulaAtoms( formula->u.flist.formula, parameters, atoms );
      collectPlainFormulaAtoms( formula->u.flist.next, parameters, atoms );
      break;
    case UNKNOWN_FORMULA:
    case ONEOF_FORMULA:
    case OR_FORMULA:
    default:
      printf( "parser(collectPlainFormulaAtoms): unexpected formula type %d\n", formula->type );
      break;
    }
}

void
collectPlainFormulaCertainAtoms( formula_t* formula, std::set<int> &atoms )
{
  if( formula == NULL ) return;
  switch( formula->type )
    {
    case ATOMIC_FORMULA:
      if( !formula->u.atomic.equal )
	{
	  int atom = atomId( formula, 0 );
	  int a = (formula->u.atomic.neg?-int(atom):int(atom));
	  atoms.insert( a );
	}
      break;
    case AND_FORMULA:
      for( formula_t *f = formula->u.formula; f != NULL; f = f->u.flist.next )
	collectPlainFormulaCertainAtoms( f->u.flist.formula, atoms );
      break;
    case NOT_FORMULA: 
      if ( formula->u.formula->type != ATOMIC_FORMULA )
	{
	  printf( "parser(collectPlainFormulaCertainAtoms): not of a non atomic formula\n");
	  exit(1);
	}
      collectPlainFormulaCertainAtoms( formula->u.formula, atoms );
      break;
    case LIST_FORMULA:
      collectPlainFormulaCertainAtoms( formula->u.flist.formula, atoms );
      collectPlainFormulaCertainAtoms( formula->u.flist.next, atoms );
      break;
    case UNKNOWN_FORMULA:
    case ONEOF_FORMULA:
    case OR_FORMULA:
      break;
    default:
      printf( "parser(collectPlainFormulaCertainAtoms): unexpected formula type %d\n", formula->type );
      break;
    }
}

// Some atoms that appear for sure on every model (simplest case)
void
collectPlainFormulaPosAtoms( formula_t* formula, std::set<int> &atoms )
{
  if( formula == NULL ) return;
  switch( formula->type )
    {
    case ATOMIC_FORMULA:
      if( !formula->u.atomic.equal )
	{
	  int atom = atomId( formula, 0 );
	  int a = (formula->u.atomic.neg?-int(atom):int(atom));
	  atoms.insert( a );
	}
      break;
    case AND_FORMULA:
      for( formula_t *f = formula->u.formula; f != NULL; f = f->u.flist.next )
	collectPlainFormulaPosAtoms( f->u.flist.formula, atoms );
      break;
      break;
    case LIST_FORMULA:
      collectPlainFormulaPosAtoms( formula->u.flist.formula, atoms );
      collectPlainFormulaPosAtoms( formula->u.flist.next, atoms );
      break;
    case NOT_FORMULA: 
    case UNKNOWN_FORMULA:
    case OR_FORMULA:
    case ONEOF_FORMULA:
      break;
    default:
      printf( "parser(collectPlainFormulaPosAtoms): unexpected formula type %d\n", formula->type );
      break;
    }
}


bool
isComplexFormula2( formula_t* formula )
{
  bool val = false;
  if( formula == NULL ) return false;
  switch( formula->type )
    {
    case ATOMIC_FORMULA:
      return false;
      break;
    case ONEOF_FORMULA:
    case AND_FORMULA:
      for( formula_t *f = formula->u.formula; f != NULL; f = f->u.flist.next )
	val = val || isComplexFormula2( f->u.flist.formula );
      break;
    case UNKNOWN_FORMULA:
      val = val || isComplexFormula2( formula->u.formula );
    case NOT_FORMULA: 
      if ( formula->u.formula->type == ATOMIC_FORMULA )
	return false;
      else
	return true;
      break;
    case LIST_FORMULA:
      val = val || isComplexFormula2( formula->u.flist.formula );
      val = val || isComplexFormula2( formula->u.flist.next );
      break;
    case OR_FORMULA:
      return true;
    }
  return val;
}

bool
isComplexFormula( formula_t* formula )
{
  bool val = false;
  if( formula == NULL ) return false;
  switch( formula->type )
    {
    case ATOMIC_FORMULA:
      return false;
      break;
    case AND_FORMULA:
      for( formula_t *f = formula->u.formula; f != NULL; f = f->u.flist.next )
	val = val || isComplexFormula( f->u.flist.formula );
      break;
    case NOT_FORMULA: 
      if ( formula->u.formula->type == ATOMIC_FORMULA )
	return false;
      else
	return true;
      break;
    case LIST_FORMULA:
      val = val || isComplexFormula( formula->u.flist.formula );
      val = val || isComplexFormula( formula->u.flist.next );
      break;
    case UNKNOWN_FORMULA:
    case ONEOF_FORMULA:
    case OR_FORMULA:
      return true;
    }
  return val;
}

static int
collectCondEffectAtoms( formula_t *formula, int *parameters,  
			std::vector<int>& atoms, Act &act, vector<int>* r2a,
			const std::set<int>* reachable_atoms,
			const std::set<int>* static_positive_atoms = 0 )
{
  int total = 0;
  const bool debugit = false;

  switch( formula->type )
    {
    case LIST_FORMULA:
      for( formula_t *eff = formula; eff != 0; eff = eff->u.flist.next )
	total += collectCondEffectAtoms( eff->u.flist.formula, parameters, atoms, act, r2a,
					 reachable_atoms,
					 static_positive_atoms );
      break;
    case ATOMIC_FORMULA:
      break;
    case SET_FORMULA:
      assert( 0 );
      break;
    case WHEN_EFFECT:
      {
	total = 1;
	When w;
	atoms.clear();
	collectPlainFormulaAtoms( formula->u.when.formula, parameters, atoms );
	for( size_t i = 0; i < atoms.size(); ++i )
	  {
	    size_t old_a = atoms[i]>>1;
	    size_t a = 0;
	    if( r2a )
	      {
		if( (atoms[i]>>1) >= r2a->size() )
		  {
		    cout << "av = " <<  (atoms[i]>>1) 
			 << ", r2a = " << r2a->size() << endl;
		  }
		assert( (atoms[i]>>1) < r2a->size() );
		a = (*r2a)[atoms[i]>>1];
	      }
	    else
	      a = old_a;
	    if(debugit)
	      cout << "in When: considering condition atom " << (atoms[i] % 2?-1:1)*old_a 
		   << ". new value = " << a << endl;
	    if( atoms[i] % 2 )
	      {
		// Can't be made positive
		if( static_positive_atoms && static_positive_atoms->count( old_a ) > 0 )
		  {
		    if(debugit)
		      cout << "rejecting because atom " << old_a  << " is static " << endl;
		    // Isn't right
		    //act.conds.pop_back();
		    return 0;
		  }
		w.prec.insert( -a );
	      }
	    else
	      {
		// Adding non-static atoms
		if( !static_positive_atoms || static_positive_atoms->count( old_a ) == 0 ) 
		  {
		    if( reachable_atoms && reachable_atoms->count( old_a ) == 0 ) 
		      {
			if(debugit)
			  cout << "rejecting because can't reach atom " << old_a << endl;
			return 0;
		      }
		    w.prec.insert( a );
		    if(debugit)
		      cout << "Adding atom " << a << endl;
		  }
		else if(debugit)
		  cout << "rejecting because is static and positive " << old_a << endl;
	      }
	  }
	if(debugit)
	  cout << "Prec of condition size: " << w.prec.size() << endl;
	atoms.clear();
	collectPlainFormulaAtoms( formula->u.when.effect, parameters, atoms );
	  for( size_t i = 0; i < atoms.size(); ++i )
	    {
	      if( r2a && (atoms[i]>>1) >= r2a->size() )
		{
		  cout << "av = " <<  (atoms[i]>>1) 
		       << ", r2a = " << r2a->size() << endl;
		  assert( (atoms[i]>>1) < r2a->size() );
		}
	      size_t a;
	      if( r2a )
		a = (*r2a)[atoms[i]>>1];
	      else
		a = atoms[i]>>1;
	      if( atoms[i] % 2 )
		w.eff.insert( -a );
	      else
		w.eff.insert( a );
	      if(debugit)
		cout << "in When: considering effect atom " << (atoms[i] % 2?-1:1)*(atoms[i]>>1)
		     << ". new value = " << a << endl;
	    }
	atoms.clear();
	if( w.prec.size() == 0 )
	  for( set<int>::iterator e = w.eff.begin();
	       e != w.eff.end(); ++e )
	    act.eff.insert(*e);
	else
	  act.addWhen(w);
	if(debugit)
	  {
	    cout << "now action is ";
	    act.dump(cout);
	  }
      }
      break;
    default:
      printf( "parse(collectCondEffectAtoms): unexpected formula type %d\n", formula->type );
      break;
    }
  return total;
}

bool
operatorAtomsWhen( schema_t *schema, int *parameters, Act &act, vector<int>* r2a,
		   const std::set<int>& reachable_atoms,
		   const std::set<int>* static_positive_atoms = 0 )
{
  const bool debugit = false;

  std::vector<int> atoms_vec;
  collectPlainFormulaAtoms( schema->prec, parameters, atoms_vec );
  for( size_t i = 0; i < atoms_vec.size(); ++i )
    {
      int old_a = atoms_vec[i]>>1;
      size_t a = 0;
      if( r2a ) 
	{
	  if( (atoms_vec[i]>>1) >= r2a->size() )
	    {
	      cerr << "FATAL ERROR: av = " <<  (atoms_vec[i]>>1) 
		   << ", r2a = " << r2a->size() << endl;
	    }
	  assert( (atoms_vec[i]>>1) < r2a->size() );
	  a = (*r2a)[atoms_vec[i]>>1];
	}
      else
	a = old_a;
      if(debugit)
	cout << "considering atom " << (atoms_vec[i] % 2?-1:1)*old_a << ". new value = " << a << endl;
      if( atoms_vec[i] % 2 )
	{
	  // Can't be made positive
	  if( static_positive_atoms && static_positive_atoms->count( old_a ) > 0 )
	    {
	      if(debugit)
		cout << "rejecting because atom " << old_a << endl;
	      return false;
	    }

	  if( reachable_atoms.count( old_a ) != 0 )
	    { // Can be made positive, so we can't remove it
	      cerr << "FATAL ERROR: Non-static negative preconditions not supported. Final check" << endl;
	      exit(1);
	    }
	}
      else
	{
	  if( !static_positive_atoms || static_positive_atoms->count( old_a ) == 0 ) 
	    {
	      if(debugit)
		cout << "Adding atom " << a << endl;
	      act.prec.insert( a );
	    }
	}
    }
  if(debugit)
    cout << "Prec of action size: " << act.prec.size() << endl;

  atoms_vec.clear();
  collectUncondEffectAtoms( schema->effect, parameters, atoms_vec );
  for( size_t i = 0; i < atoms_vec.size(); ++i )
    {
      if( r2a && (atoms_vec[i]>>1) >= r2a->size() )
	{
	  cout << "av = " <<  (atoms_vec[i]>>1) 
	       << ", r2a = " << r2a->size() << endl;
	  assert( (atoms_vec[i]>>1) < r2a->size() );
	}

      size_t a;
      if( r2a )
	a = (*r2a)[atoms_vec[i]>>1];
      else
	a = atoms_vec[i]>>1;

      if( atoms_vec[i] % 2 )
	act.eff.insert( -a );
      else
	act.eff.insert( a );
    }
  int added = collectCondEffectAtoms( schema->effect, parameters, atoms_vec, act, r2a, 
				      &reachable_atoms, static_positive_atoms );
  if( act.eff.size() == 0 && added == 0 )
    return false; // Do nothing
  else
    return true;
}

void
operatorAtoms( schema_t *schema, int *parameters, std::set<int> &atoms )
{
  std::vector<int> atoms_vec;
  collectAllAtoms( schema->prec, parameters, atoms_vec );
  collectAllAtoms( schema->effect, parameters, atoms_vec );
  for( size_t i = 0; i < atoms_vec.size(); ++i )
    atoms.insert( atoms_vec[i] >> 1 );
}

void
formulaAtomsPos( formula_t *formula, int *parameters, int phase, std::set<int> &atoms )
{
  std::vector<int> atoms_vec;
  collectFormulaAtoms( formula, parameters, atoms_vec );
  for( size_t i = 0; i < atoms_vec.size(); ++i )
    if( (atoms_vec[i] % 2) == phase )
      atoms.insert( atoms_vec[i] >> 1 );
}

void
formulaAtoms( formula_t *formula, int *parameters, std::set<int> &atoms )
{
  std::vector<int> atoms_vec;
  collectFormulaAtoms( formula, parameters, atoms_vec );
  for( size_t i = 0; i < atoms_vec.size(); ++i )
    atoms.insert( atoms_vec[i] >> 1 );
}

void
formulaLiterals( formula_t *formula, int *parameters, std::set<int> &atoms )
{
  std::vector<int> atoms_vec;
  collectFormulaAtoms( formula, parameters, atoms_vec );
  for( size_t i = 0; i < atoms_vec.size(); ++i )
    if( atoms_vec[i] % 2) 
      atoms.insert( -(atoms_vec[i] >> 1) );
    else
      atoms.insert( atoms_vec[i] >> 1 );
}

